### PyFluxconserving
####  Fully based on a Fortran legacy package to easily compute the flux-density conservation
Obs.: A Fortran legacy Interpolation routines also furnished in this package <br>
email: [antineutrinomuon@gmail.com](mailto:antineutrinomuon@gmail.com)

linkedin: <a href="https://www.linkedin.com/in/jean-michel-gomes/">https://www.linkedin.com/in/jean-michel-gomes/</a>

github repository: <a href="https://github.com/neutrinomuon/PyFluxconserving">PyFluxconserving</a>

last stable version: 0.0.16

© Copyright ®

J.G. - Jean Gomes @ 2025

<hr>

<img src="https://skillicons.dev/icons?i=python,fortran,c,numpy&theme=light"><br>
<img src="https://img.shields.io/pypi/pyversions/PyFluxconserving"><img src="https://anaconda.org/neutrinomuon/PyFluxconserving/badges/license.svg">

<hr>

<div align="center">
<img src='https://raw.githubusercontent.com/neutrinomuon/PyFluxconserving/main/figures/PyFluxconserving_.png' width='60%'>
</div>

<hr>

#### <b>RESUME</b>

<img
src="https://raw.githubusercontent.com/neutrinomuon/PyFluxconserving/main/figures/PyFluxconserving.png"
width=120>

Original Fortran 2003+ legacy routines date back to 2003–2004. Please
refer to the <a
href='https://github.com/neutrinomuon/PyFluxconserving/blob/main/LICENSE.txt'>LICENSE.txt</a>
file. These routines have been converted into Python libraries.

When analysing astronomical spectra, astronomers often bin the data to
increase the signal-to-noise ratio and mitigate the effects of
noise. Binning refers to the process of averaging the intensity of
adjacent spectral channels, or pixels, to produce a new, coarser
dataset.

During binning, it is crucial to maintain the principle of flux
density conservation. This means that the total energy emitted by the
object, and consequently its flux density, must remain constant after
binning.

To conserve flux density, the intensity of each binned pixel should be
scaled according to the number of pixels it represents. For instance,
if two adjacent pixels are binned together, the intensity of the
resulting bin should equal the sum of the intensities of the two
original pixels, divided by two. This ensures that the total energy in
the bin is conserved and that the object's flux density remains
unchanged.

It is important to note that binning can introduce errors in spectral
data, especially if the signal-to-noise ratio is low or if the binning
is too coarse. Nevertheless, this procedure is often necessary, as the
observed spectrum of an astronomical source is generally
non-linear. Astronomers usually choose a binning size that balances
the need for a high signal-to-noise ratio with the requirement to
maintain spectral resolution and minimise significant errors in the
data.

In summary, flux density conservation is a key consideration when
binning astronomical spectra. Astronomers must scale the intensity of
each binned pixel to ensure that the total energy emitted by the
object is preserved.

Note: SpectRes by A. Carnall is not included in this distribution but
is provided for comparison: <a
href='https://github.com/ACCarnall/SpectRes'>https://github.com/ACCarnall/SpectRes
</a>. To install it for comparison, please refer to the repository.
However, it is not necessary for the usage of this
package. Accompanying there are several routines for interpolations.

<hr>

#### <b>INSTALLATION</b>

You can easily install <a
href=https://pypi.org/project/PyFluxconserving/>PyFluxconserving</a> by using pip -
<a href='https://pypi.org/'>PyPI - The Python Package Index</a>:

<pre>
pip install PyFluxconserving
</pre>

<br>or by using a generated conda repository <a
href='https://anaconda.org/neutrinomuon/PyFluxconserving'>https://anaconda.org/neutrinomuon/PyFluxconserving</a>:

<img src="https://anaconda.org/neutrinomuon/PyFluxconserving/badges/version.svg"><img src="https://anaconda.org/neutrinomuon/PyFluxconserving/badges/latest_release_date.svg"><img src="https://anaconda.org/neutrinomuon/PyFluxconserving/badges/platforms.svg">

<pre>
conda install -c neutrinomuon PyFluxconserving
</pre>

<br>OBS.: Linux, OS-X and Windows pre-compilations available in conda.

You can also clone the repository and install by yourself in your machine:

<pre>
git clone https://github.com/neutrinomuon/PyFluxconserving
pip install --user ninja (optional)
pip install --user meson (optional)
rm -rf build *.egg-info PyFluxconserving
python setup.py build_ext --inplace
pip install -e .
</pre>

<hr>

#### <b>METHOD & REFERENCES</b>

Here, the method used is with the Cumulative function to produce a new
flux-conserved, some options can be chosen for the interpolation:

<table border="1">

<tr><td width='20%'>Integer Number</td><td width='33%'>Option: Interpolation Schemes</td><td>Brief Description</td></tr>

<tr><td>0)</td><td>AkimaSpline</td><td>Akima Spline interpolation. The Akima spline is a C1 differentiable function (that is, has a continuous first
derivative) but, in general, will have a discontinuous second derivative at the knot points.<p>

<ul>
<il>Akima, H. (1970). A New Method of Interpolation and Smooth Curve Fitting Based on Local Procedures. <i>Journal of the ACM</i>, 17(4),
589-602. Association for Computing Machinery. DOI: 10.1145/321607.321609. Link: <a href="https://dl.acm.org/doi/10.1145/321607.321609">https://dl.acm.org/doi/10.1145/321607.321609</a></il><p>

<il>De Boor, C. (1978). A Practical Guide to Splines. Springer-Verlag. ISBN: 978-0-387-95366-3. Link: <a href="https://www.springer.com/gp/book/9780387953663">https://www.springer.com/gp/book/9780387953663</a></il><p>

<il>Forsythe, G.E. (1979) <i>Computer Methods for Mathematical Computations</i>. Prentice-Hall, Inc. DOI: 10.1002/zamm.19790590235. Link: <a href="https://onlinelibrary.wiley.com/doi/10.1002/zamm.19790590235">https://onlinelibrary.wiley.com/doi/10.1002/zamm.19790590235</a></il><p>

<il>Bartels, R.H., Beatty, J.C., and Barsky, B.A. (1987). An Introduction to Splines for Use in Computer Graphics and Geometric Modeling. Morgan Kaufmann
Publishers. Link: <a href="https://www.osti.gov/biblio/5545263">https://www.osti.gov/biblio/5545263</a></il><p>

<il>Press, W. H., Teukolsky, S. A., Vetterling, W. T., &amp; Flannery, B. P. (2007). Numerical Recipes: The Art of Scientific Computing (3rd
ed.). Cambridge University Press. ISBN: 978-0521880688. Link: <a href="http://numerical.recipes/">http://numerical.recipes/</a></il><p>

<il>Cheney, W. and Kincaid, D. (2008). Numerical Mathematics and Computing (6th ed.). Brooks/Cole. ISBN: 978-0495114758. Link: <a href="https://www.amazon.com/Numerical-Mathematics-Computing-Ward-Cheney/dp/0495114758">https://www.amazon.com/Numerical-Mathematics-Computing-Ward-Cheney/dp/0495114758</a></il><p>

<il>Burden, R. L., &amp; Faires, J. D. (2010). Numerical Analysis (9th ed.). Brooks/Cole. ISBN: 978-0538733519. Link: <a href="https://www.amazon.com/Numerical-Analysis-Richard-L-Burden/dp/0538733519">https://www.amazon.com/Numerical-Analysis-Richard-L-Burden/dp/0538733519</a></il><p>

</ul>

</td></tr>

<tr><td>1)</td><td>Interpolado</td><td>Based on a linear interpolation within
a table of pair values.<p>

<ul>

<il>Atkinson, K. E. (1991). <i>An introduction to numerical analysis</i> (2nd ed.). John Wiley & Sons. ISBN: 978-0-471-62489-9. Link: <a href="https://www.wiley.com/en-us/An+Introduction+to+Numerical+Analysis%2C+2nd+Edition-p-9780471624899">https://www.wiley.com/en-us/An+Introduction+to+Numerical+Analysis%2C+2nd+Edition-p-9780471624899</a></il><p>

<il>Press, W. H., Teukolsky, S. A., Vetterling, W. T., &amp; Flannery, B. P. (2007). <em>Numerical Recipes: The Art of Scientific Computing</em> (3rd
ed.). Cambridge University Press. ISBN: 978-0521880688. Link: <a href="http://numerical.recipes/">http://numerical.recipes/</a></il><p>

<il>Chapra, S. C., & Canale, R. P. (2010). <i>Numerical methods for engineers</i> (6th ed.). McGraw-Hill. ISBN: 978-0073401065. Link: <a href="https://www.amazon.com/Numerical-Methods-Engineers-Steven-Chapra/dp/0073401064">https://www.amazon.com/Numerical-Methods-Engineers-Steven-Chapra/dp/0073401064</a></il><p>

<il>Burden, R. L., Faires, J. D. & A.M. Burden (2015). <i>Numerical analysis (10th ed.)</i> (9th ed.). Cengage Learning. ISBN: 978-1305253667. Link: <a href="https://www.amazon.com/Numerical-Analysis-Richard-L-Burden/dp/1305253663">https://www.amazon.com/Numerical-Analysis-Richard-L-Burden/dp/1305253663</a></il><p>

</ul>

</td></tr>

<tr><td>2)</td><td>LINdexerpol</td><td>Based on a linear interpolation within
a table of pair values using indexing. The references are the same as in
1).</td></tr>

<tr><td>3)</td><td>LINinterpol</td><td>Based on a linear interpolation within
a table of pair values. The references are the same as in 1).</td></tr>

<tr><td>4)</td><td>SPLINE1DArr</td><td>This is a Fortran 2003 subroutine
called SPLINE1DArr that takes an array of values x to interpolate from the
arrays t and y. It has ten input arguments, six output arguments, and two
optional arguments. The interpolation is linear.<p>

<ul>
<il>Forsythe, G.E. (1977) <em>Computer Methods For Mathematical Computations</em>. Ed. Prentice-Hall, Inc. <a href="https://onlinelibrary.wiley.com/doi/abs/10.1002/zamm.19790590235">https://onlinelibrary.wiley.com/doi/abs/10.1002/zamm.19790590235</a></il><p>

<il>De Boor, C. (1978). <em>A Practical Guide to Splines</em>. Springer-Verlag. ISBN: 978-0-387-95366-3. Link: <a href="https://www.springer.com/gp/book/9780387953663">https://www.springer.com/gp/book/9780387953663</a></il><p>

<il>Bartels, R.H., Beatty, J.C., and Barsky, B.A. (1998). <em>An Introductionto Splines for Use in Computer Graphics and Geometric Modeling</em>. Morgan
Kaufmann Publishers. ISBN: 978-1558604000. Link: <a href="https://www.amazon.com/Introduction-Computer-Graphics-Geometric-Modeling/dp/1558604006">https://www.amazon.com/Introduction-Computer-Graphics-Geometric-Modeling/dp/1558604006</a></il><p>

<il>Press, W. H., Teukolsky, S. A., Vetterling, W. T., &amp; Flannery, B. P. (2007). <em>Numerical Recipes: The Art of Scientific Computing</em> (3rd
ed.). Cambridge University Press. ISBN: 978-0521880688. Link: <a href="http://numerical.recipes/">http://numerical.recipes/</a></il><p>

<il>Cheney, W. and Kincaid, D. (2007). <em>Numerical Mathematics and Computing</em> (6th ed.). Brooks/Cole. ISBN: 978-0495114758. Link: <a href="https://www.amazon.com/Numerical-Mathematics-Computing-Ward-Cheney/dp/0495114758">https://www.amazon.com/Numerical-Mathematics-Computing-Ward-Cheney/dp/0495114758</a></il><p>

</td></tr>

<tr><td>5)</td><td>SPLINE3DFor</td><td>This function evaluates the cubic
spline interpolation. The same references as in 4).</td></tr>

</table>

<hr>

#### <b>STRUCTURE</b>
<pre>
#################################################
workspace
├── version.txt
├── .github
│   └── workflows
│       ├── main.yml
│       └── pylint.yml
├── src
│   ├── fortran
│   │   ├── Interpolado.compile
│   │   ├── SPLINE3DFor.cpython-310-x86_64-linux-gnu.so
│   │   ├── LINdexerpol.cpython-311-darwin.so
│   │   ├── SPLINE3DFor.cpython-310-darwin.so
│   │   ├── LINinterpol.compile
│   │   ├── AkimaSpline.cpython-311-darwin.so
│   │   ├── Interpolado.f90
│   │   ├── FluxConSpec.cpython-311-darwin.so
│   │   ├── Interpolado.cpython-310-x86_64-linux-gnu.so
│   │   ├── SPLINE1DArr.f90
│   │   ├── SPLINE1DFlt.f90
│   │   ├── Interpolado.cpython-39-x86_64-linux-gnu.so
│   │   ├── FluxConSpec.cpython-310-x86_64-linux-gnu.so
│   │   ├── SPLINE1DArr.cpython-39-darwin.so
│   │   ├── SPLINE1DFlt.cpython-310-x86_64-linux-gnu.so
│   │   ├── AkimaSpline.cpython-312-x86_64-linux-gnu.so
│   │   ├── SPLINE1DArr.cpython-310-darwin.so
│   │   ├── LINdexerpol.cpython-310-x86_64-linux-gnu.so
│   │   ├── AkimaSpline.cpython-310-darwin.so
│   │   ├── Interpolado.cpython-38-x86_64-linux-gnu.so
│   │   ├── SPLINE3DFor.f90
│   │   ├── LINinterpol.cpython-311-x86_64-linux-gnu.so
│   │   ├── SPLINE3DFor.cpython-39-darwin.so
│   │   ├── SPLINE1DFlt.compile
│   │   ├── FluxConSpec.f90
│   │   ├── FluxConSpec.cpython-39-x86_64-linux-gnu.so
│   │   ├── FluxConSpec.cpython-310-darwin.so
│   │   ├── SPLINE3DFor.cpython-311-darwin.so
│   │   ├── LINinterpol.f90
│   │   ├── SPLINE1DFlt.cpython-39-x86_64-linux-gnu.so
│   │   ├── AkimaSpline.compile
│   │   ├── SPLINE3DFor.compile
│   │   ├── AkimaSpline.cpython-39-darwin.so
│   │   ├── LINinterpol.cpython-310-darwin.so
│   │   ├── FluxConSpec.cpython-39-darwin.so
│   │   ├── LINinterpol.cpython-310-x86_64-linux-gnu.so
│   │   ├── LINdexerpol.f90
│   │   ├── SPLINE1DFlt.cpython-311-darwin.so
│   │   ├── SPLINE1DFlt.cpython-39-darwin.so
│   │   ├── README.txt
│   │   ├── SPLINE3DFor.cpython-38-x86_64-linux-gnu.so
│   │   ├── FluxConSpec.compile
│   │   ├── DataTypes.f90
│   │   ├── LINdexerpol.compile
│   │   ├── Interpolado.cpython-312-x86_64-linux-gnu.so
│   │   ├── LINdexerpol.cpython-38-x86_64-linux-gnu.so
│   │   ├── SPLINE1DArr.compile
│   │   ├── LINdexerpol.cpython-310-darwin.so
│   │   ├── SPLINE1DFlt.cpython-38-x86_64-linux-gnu.so
│   │   ├── LINinterpol.cpython-311-darwin.so
│   │   ├── AkimaSpline.cpython-38-x86_64-linux-gnu.so
│   │   ├── FluxConSpec.cpython-38-x86_64-linux-gnu.so
│   │   ├── SPLINE3DFor.cpython-39-x86_64-linux-gnu.so
│   │   ├── SPLINE1DArr.cpython-311-darwin.so
│   │   ├── AkimaSpline.f90
│   │   ├── SPLINE1DFlt.cpython-310-darwin.so
│   │   ├── LINdexerpol.cpython-39-darwin.so
│   │   ├── LINinterpol.cpython-39-darwin.so
│   │   └── LINdexerpol.cpython-39-x86_64-linux-gnu.so
│   └── python
│       ├── __init__.py
│       ├── PyAkimaSpline.py
│       ├── fluxconserve.py
│       ├── PyInterpolado.py
│       ├── PySPLINE1DArr.py
│       ├── PyLinear__int.py
│       ├── PyLINdexerpol.py
│       ├── califa_cmap_alternative.py
│       ├── PySPLINE3DFor.py
│       ├── fluxconserving.png
│       ├── PyFluxConSpec.py
│       └── PyLINinterpol.py
├── scripts
│   └── update_readme.py
├── build
│   ├── lib.macosx-11.0-arm64-cpython-39
│   │   └── PyFluxconserving
│   │       ├── __init__.py
│   │       ├── PyAkimaSpline.py
│   │       ├── fluxconserve.py
│   │       ├── PyInterpolado.py
│   │       ├── PySPLINE1DArr.py
│   │       ├── PyLinear__int.py
│   │       ├── PyLINdexerpol.py
│   │       ├── flib.cpython-39-darwin.so
│   │       ├── califa_cmap_alternative.py
│   │       ├── PySPLINE3DFor.py
│   │       ├── PyFluxConSpec.py
│   │       └── PyLINinterpol.py
│   ├── src.macosx-11.0-arm64-3.9
│   │   ├── build
│   │   │   └── src.macosx-11.0-arm64-3.9
│   │   │       └── PyFluxconserving
│   │   │           ├── fortranobject.c
│   │   │           └── fortranobject.h
│   │   ├── numpy
│   │   │   └── distutils
│   │   │       └── include
│   │   │           └── npy_cpu_dispatch_config.h
│   │   └── PyFluxconserving
│   │       ├── flib-f2pywrappers.f
│   │       ├── flibmodule.c
│   │       └── flib-f2pywrappers2.f90
│   └── temp.macosx-11.0-arm64-cpython-39
│       ├── src
│       │   └── fortran
│       │       ├── LINdexerpol.o
│       │       ├── DataTypes.o
│       │       ├── LINinterpol.o
│       │       ├── FluxConSpec.o
│       │       ├── AkimaSpline.o
│       │       ├── SPLINE1DArr.o
│       │       ├── Interpolado.o
│       │       └── SPLINE3DFor.o
│       ├── build
│       │   └── src.macosx-11.0-arm64-3.9
│       │       ├── build
│       │       │   └── src.macosx-11.0-arm64-3.9
│       │       │       └── PyFluxconserving
│       │       │           ├── fortranobject.o
│       │       │           └── fortranobject.o.d
│       │       └── PyFluxconserving
│       │           ├── flib-f2pywrappers2.o
│       │           ├── flibmodule.o
│       │           ├── flibmodule.o.d
│       │           └── flib-f2pywrappers.o
│       ├── __pycache__
│       │   └── ccompiler_opt_cache_ext.cpython-39.pyc
│       ├── ccompiler_opt_cache_ext.py
│       └── PyFluxconserving
│           └── moddatatype.mod
├── dist
│   ├── pyfluxconserving-0.1.16-py3-none-any.whl
│   └── pyfluxconserving-0.1.16.tar.gz
├── requirements.txt
├── requirements.py
├── README.md
├── setup.py
├── tutorials
│   ├── PyFluxconserving Example.ipynb
│   ├── .virtual_documents
│   │   └── PyFluxconserving Example.ipynb
│   └── .ipynb_checkpoints
│       ├── pyfluxconserving Example-checkpoint.ipynb
│       └── PyFluxconserving Example-checkpoint.ipynb
├── figures
│   ├── PyFluxconserving_.png
│   └── PyFluxconserving.png
├── showdown.min.js
├── index.html
├── LICENSE.txt
├── PyFluxconserving
│   ├── __init__.py
│   ├── PyAkimaSpline.py
│   ├── fluxconserve.py
│   ├── PyInterpolado.py
│   ├── PySPLINE1DArr.py
│   ├── PyLinear__int.py
│   ├── __pycache__
│   │   ├── PyFluxConSpec.cpython-312.pyc
│   │   ├── califa_cmap_alternative.cpython-312.pyc
│   │   ├── __init__.cpython-312.pyc
│   │   └── fluxconserve.cpython-312.pyc
│   ├── flib.pyf
│   ├── flib.cpython-312-x86_64-linux-gnu.so
│   ├── PyLINdexerpol.py
│   ├── califa_cmap_alternative.py
│   ├── PySPLINE3DFor.py
│   ├── PyFluxConSpec.py
│   └── PyLINinterpol.py
├── README_setup.txt
├── .git
│   ├── logs
│   │   ├── HEAD
│   │   └── refs
│   │       ├── remotes
│   │       │   └── origin
│   │       │       └── main
│   │       └── heads
│   │           └── main
│   ├── config
│   ├── HEAD
│   ├── refs
│   │   ├── remotes
│   │   │   └── origin
│   │   │       └── main
│   │   ├── heads
│   │   │   └── main
│   │   └── tags
│   ├── config.worktree
│   ├── FETCH_HEAD
│   ├── description
│   ├── hooks
│   │   ├── sendemail-validate.sample
│   │   ├── pre-receive.sample
│   │   ├── fsmonitor-watchman.sample
│   │   ├── prepare-commit-msg.sample
│   │   ├── post-update.sample
│   │   ├── pre-rebase.sample
│   │   ├── push-to-checkout.sample
│   │   ├── pre-merge-commit.sample
│   │   ├── pre-applypatch.sample
│   │   ├── pre-commit.sample
│   │   ├── commit-msg.sample
│   │   ├── applypatch-msg.sample
│   │   ├── pre-push.sample
│   │   └── update.sample
│   ├── index
│   ├── objects
│   │   ├── pack
│   │   │   ├── pack-46f3154c766289426b0cda7512267f9284038e5e.rev
│   │   │   ├── pack-46f3154c766289426b0cda7512267f9284038e5e.idx
│   │   │   └── pack-46f3154c766289426b0cda7512267f9284038e5e.pack
│   │   └── info
│   ├── shallow
│   └── info
│       └── exclude
├── pyfluxconserving
│   └── meta.yaml
├── tree.out
└── PyFluxconserving.egg-info
    ├── PKG-INFO
    ├── dependency_links.txt
    ├── top_level.txt
    └── SOURCES.txt

53 directories (0 symlink), 179 files (0 symlink)
#################################################
Generated: treehue_colored @2025 - © Jean Gomes -
#################################################
</pre>

<br>PyFluxConSPec.py is a python wrapper to the library in fortran called
PyFluxconserving.flib. The fortran directory can be compiled separately for
each individual subroutine.

<hr>

#### ISSUES AND CONTRIBUTIONS

If you encounter any issues with this project, please feel free to submit an issue on the GitHub repository. We appreciate your feedback and are committed to improving the quality of our codebase.

If you'd like to contribute to this project, we welcome pull requests from the community. Before submitting a pull request, please make sure to fork the repository and create a new branch for your changes. Once your changes are complete, submit a pull request and we'll review your code as soon as possible.

For any questions or concerns about contributing, please contact the project maintainer at antineutrinomuon@gmail.com. Thank you for your interest in contributing to our project!

<hr>

#### <b>LICENSE</b>

This software is provided "AS IS" (see DISCLAIMER below). Permission to
use, for non-commercial purposes is granted. Permission to modify for personal
or internal use is granted, provided this copyright and disclaimer are
included in ALL copies of the software. All other rights are reserved. In
particular, redistribution of the code is not allowed without explicit
permission by the author.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

! ###########################################################################
!     RESUME : For a given array of values 'xx_value' for the               !
!              abscissa, then return the ordinate array values of           !
!              'yy_value' based on a linear interpolation within a          !
!              table of pair values [xold_vec, yold_vec]. This              !
!              subroutine assumes that the values in the array              !
!              xold_vec increases monotonically with yold_vec. There        !
!              is a trick to increase efficiency by remembering the         !
!              table points used in the last call                           !
!              (ilastval). Actually, it does not make a huge                !
!              difference. However, this should be used with                !
!              care. Whenever the data set is changed it is highly          !
!              recommended to set ilastval as a negative number (e.g.:      !
!              islastval = -999) in order to reset the table                !
!              indexing. The values xold_vec and yold_vec are arrays        !
!              and their length is nold_vec. If an interpolated point       !
!              lies outside the pair of elements (xold_vec,yold_vec),       !
!              then a zero value is returned.                               !
!                                                                           !
!     Input           arguments = 6                                         !
!     Output          arguments = 3                                         !
!     Optional        arguments = 1                                         !
!     Total number of arguments = 10                                        !
!                                                                           ! 
!     INPUT  : 01) xx_value  -> New interpolated x array with points        !
!              02) nxyvalue  -> # of elements in xx_value and yy_value      !
!              02) xold_vec  -> Old x vector (abcissas)                     !
!              03) yold_vec  -> Old y vector (ordenadas)                    !
!              04) nold_vec  -> # of elements in xold_vec and yold_vec      !
!              05) ilastval  -> Last integer number used and stored         !
!              07) verbosity -> Print & Check screen                        !
!                                                                           !
!     OUTPUT : 01) yy_value -> New interpolated y array with points         !
!              02) ilastval  -> Last integer number used and stored         !
!              03) IsKeepOn  -> [1: Executed, 0: Problem]                   !  
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Wed May  2 10:00:52 WEST 2012                                !
!              Fri Dec 28 13:53:36 WET  2012                                !
!              Sun Mar 10 10:05:03 WET  2013                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE LINinterpol( xx_value,yy_value,nxyvalue,xold_vec,yold_vec,       &
                        nold_vec,ilastval,IsKeepOn,verbosity )

    use ModDataType

    implicit none
    integer  (kind=IB), intent(in out) :: ilastval
    integer  (kind=IB), intent(in) :: nold_vec, nxyvalue
    integer  (kind=IB), intent(out) :: IsKeepOn
    integer  (kind=IB), optional :: verbosity
    integer  (kind=IB) :: in_loop1,in_loop2,ilastnum,IsShowOn

    real     (kind=RP), dimension(0:nold_vec-1), intent(in) :: xold_vec,yold_vec
    real     (kind=RP), dimension(0:nxyvalue-1), intent(in) :: xx_value
    real     (kind=RP), dimension(0:nxyvalue-1), intent(out) :: yy_value

    real     (kind=RP) :: width_dx
    character (len=CH) :: W1aux,W2aux,W3aux,W4aux

    !f2py real     (kind=RP), intent(in) :: xold_vec
    !f2py real     (kind=RP), intent(in) :: yold_vec
    !f2py integer  (kind=IB), intent(hide), depend(xold_vec) :: nold_vec=shape(xold_vec,0)

    !f2py real     (kind=RP), intent(in)  :: xx_value 
    !f2py real     (kind=RP), intent(out) :: yy_value 
    !f2py integer  (kind=IB), intent(hide), depend(xx_value) :: nxyvalue=shape(xx_value,0)

    !f2py integer  (kind=IB), intent(out) :: IsKeepOn
    !f2py integer  (kind=IB), intent(out) :: ilastval

    !f2py integer  (kind=IB), optional :: verbosity=0
    
    save ilastnum
    data ilastnum/1/

    if ( ilastval < 0_IB ) then
        ilastnum = -1_IB
        ilastval = -1_IB
    else
        ilastval = ilastnum
    end if

    if ( present(verbosity) ) then
        IsShowOn = verbosity
    else
        IsShowOn = 0_IB
    end if

    IsKeepOn = 1_IB
    if ( nold_vec < 1 ) then
       if ( IsShowOn == 1_IB ) then
          write (*,'(4x,a)') '[PROBLEM_INT] @@@@@@@@@@@@@@@@@@@@@@@@'
          write (*,'(4x,a)') '[LINinterpol] nold_vec < 1 dimension @'
       end if
       yy_value = -999.0_RP    
       IsKeepOn = 0_IB
       return
    end if
    
! *** Start the search from the last point of table use index ***************
    do in_loop2=0,nxyvalue-1
    
! --- Warranty that ilastnum cannot start with a higher value than nold_vec !
       if ( ilastnum + 1 > nold_vec-1 ) then
          ilastnum = nold_vec - 1
       end if
! --- Warranty that ilastnum cannot start with a higher value than nold_vec !

       if ( xx_value(in_loop2) <= xold_vec(ilastnum+1) ) then

! *** Search down the table from point of last use **************************

          in_loop1 = ilastnum + 1
          do while ( in_loop1 >= 0 .AND. xx_value(in_loop2) < xold_vec(in_loop1) )
             in_loop1 = in_loop1 - 1
             
             if ( in_loop1 < 0_IB ) then
                if ( IsShowOn == 1_IB ) then
                   write (W1aux,'(e14.4)') xx_value(in_loop2)
                   write (W2aux,'(e14.4)') xold_vec(0)
                   write (*,'(4x,a)')                                       &
                                     '[PROBLEM_INT] @@@@@@@@@@@@@@@@@@@@@@@@'
                   write (*,'(4x,a)')                                       &
                                     '[LINinterpol] Out of allowed range @@@'
                   write (*,'(4x,4(a))')                                    &
                               '[LINinterpol] ',trim(adjustl(W1aux)),' < ', &
                        trim(adjustl(W2aux))
                   !write (*,'(4x,a)')                                       &
                   !                  '[LINinterpol] LINinterpol set = 0.0 @@'
                end if
                !yy_value(in_loop2) = 0.0_RP
                !return
             end if
             
          end do
          
       else

! *** Search up the table from point of last use ****************************

          in_loop1 = ilastnum - 1
          do while ( in_loop1 <= nold_vec-1 .AND.                           &
                     xx_value(in_loop2) > xold_vec(in_loop1+1) )
             in_loop1 = in_loop1 + 1
             if ( in_loop1 > nold_vec-1 ) then
                if ( IsShowOn == 1_IB ) then
                   write (W1aux,'(e14.4)') xx_value(in_loop2)
                   write (W2aux,'(e14.4)') xold_vec(nold_vec-1)
                   write (*,'(4x,a)')                                       &
                                     '[PROBLEM_INT] @@@@@@@@@@@@@@@@@@@@@@@@'
                   write (*,'(4x,a)')                                       &
                                     '[LINinterpol] Out of allowed range @@@'
                   write (*,'(4x,4(a))')                                    &
                               '[LINinterpol] ',trim(adjustl(W2aux)),' < ', &
                               trim(adjustl(W1aux))
                   !write (*,'(4x,a)')                                       &
                   !            '[LINinterpol] LINinterpol set = 0.0 @@'
                end if
                !yy_value(in_loop2) = 0.0_RP
                !return
             end if
          end do
          
       end if

! *** Bounding points found, interpolate ************************************

       if ( in_loop1 > nold_vec-2 ) then
          in_loop1 = nold_vec-2
          !in_loop2 = nold_vec-1
       end if
       if ( in_loop1 < 0_IB ) then
          in_loop1 = 0_IB
          !in_loop2 = 1_IB
       end if

       !write (*,*) in_loop1,in_loop2,xold_vec(in_loop1),xx_value(in_loop2),xold_vec(in_loop1+1)
       
       width_dx = ( xx_value(in_loop2)   - xold_vec(in_loop1) )             &
                / ( xold_vec(in_loop1+1) - xold_vec(in_loop1) )
       yy_value(in_loop2) = (1-width_dx) * yold_vec(in_loop1)               &
                          + width_dx * yold_vec(in_loop1+1)
       ilastnum = in_loop1
       
       if ( IsShowOn == 1_IB ) then
          if ( in_loop2 == 1_IB ) then
             write (*,'(4x,a)') '[LINinterpol]'
          end if
          write (W1aux,'(f15.4)') xx_value(in_loop2)
          write (W2aux,'(f15.4)') yy_value(in_loop2)
          write (W3aux,'(i15)') ilastnum
          write (W4aux,'(i15)') ilastval
          write (*,'(4x,a,a,a,a)') '... xx_value(in_loop2): ',              &
                  trim(adjustl(W1aux)),' ==> yy_value: ',trim(adjustl(W2aux))
          write (*,'(4x,a,a)') '... ilastnum: ',trim(adjustl(W3aux))
          write (*,'(4x,a,a)') '... ilastval: ',trim(adjustl(W4aux))
       end if

    end do
    if ( IsShowOn == 1_IB ) then
       write (*,'(4x,a)') '[LINinterpol]'
    end if

    ilastval = ilastnum

    return

END SUBROUTINE LINinterpol
! ###########################################################################

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE author_LINterpol( a )
  use ModDataType

  implicit none
  
  character (len=21), intent(out) :: a

  !f2py intent(out) :: a

  a = 'Written by Jean Gomes'
  
END SUBROUTINE author_LINterpol
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Jean@Porto - Fri Sep 30 15:30:49 AZOST 2011 +++++++++++++++++++++++++++++++

! *** Test ******************************************************************
!          PROGRAM GeneralTest
!            use ModDataType
!            implicit none
!            integer  (kind=IB) :: i,j,n
!            integer  (kind=IB), parameter :: Nl_max=80000
!            integer  (kind=IB) :: IsKeepOn,Int_Type,ilastval
!            real     (kind=RP), dimension(Nl_max) :: l,f,e,m
!            real     (kind=RP) :: int,lambda_i,lambda_f,ll1,ff1,ll2,ff2
!
!           END PROGRAM GeneralTest
! *** Test ******************************************************************

! *** Number : 002                                                          !
!
! 1) LINinterpol
! 2) author_LINterpol

! ###########################################################################
!     RESUME : Spline1DArr subroutine is written in fortran 2003            !
!              standard. It takes an array of values x to                   !
!              interpolate from the arrays t and y.                         !
!                                                                           !
!     INPUT  : 01) n -> # of array elements in vector t and y               !
!              02) t -> x vector (abcissas)                                 !
!              03) y -> y vector (ordenadas)                                !
!              04) x -> Interpolate into x array                            !
!              05) m -> # of array elements in vector x and o               !
!              06) e -> epsilon machine dependent error                     !
!              07) k -> Print & Check screen (OLD fortran way)              !
!                                                                           !
!     OUTPUT : 01) o -> Interpolated y array                                !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Tue May  1 16:09:13 WEST 2012                                !
!              Fri Dec 28 14:55:10 WET  2012                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE SPLINE1DFlt( x,o,t,y,n,e,k )

    use ModDataType

    implicit none
    integer  (kind=IB), intent(in) :: n
    integer  (kind=IB), optional :: k
    integer  (kind=IB) :: i,IsShowOn
    real     (kind=RP), intent(in), dimension(0:n-1)  :: t,y

    real     (kind=RP), intent(in)  :: x
    real     (kind=RP), intent(out) :: o
    
    real     (kind=RP), optional :: e

    real     (kind=RP) :: diff, epsilon
    character (len=CH) :: w,z,r

    !f2py real     (kind=RP), intent(in) :: t,y
    !f2py                     intent(hide), depend(t) :: n=shape(t,0)
    !f2py                     intent(hide), depend(y) :: n=shape(y,0)

    !f2py real     (kind=RP), intent(in)  :: x
    !f2py                     intent(out) :: o

    !f2py real     (kind=RP), intent(in), optional :: e=1.0e-8
    
    !f2py                     intent(in), optional :: k=0
    
    intrinsic adjustl, count, present, trim

    if ( present(k) ) then
        IsShowOn = k
    else
        IsShowOn = 0_IB
    end if

    if ( present(e) ) then
       if ( e > 0.0_RP ) then
          epsilon = e
       else
          epsilon = 1.0e-8_RP
       end if
    else
       epsilon = 1.0e-8_RP
    end if

    if ( count(t(0:n-1) >= x - epsilon) == 0_IB ) then
       if ( IsShowOn == 1_IB ) then
          write (*,'(4x,a)') '[PROBLEMATIC] @@@@@@@@@@@@@@@@@@@@@@@@'
          write (*,'(4x,a)') '[SPLINE1DFor] Out of allowed range @@@'
          write (*,'(4x,a)') '[SPLINE1DFor] SPLINE1DFor set = 0.0 @@'
          write (w,'(e15.6)') x
          write (r,'(e15.6)') t(0)
          write (z,'(e15.6)') t(n-1)
          write (*,'(4x,a,a6,a,a6,a,a6)') '[SPLINE1DFor] ',trim(adjustl(w)),' => ',trim(adjustl(r)),' -- ',trim(adjustl(z))
       end if
    else if ( count(t(0:n-1) <= x + epsilon) == 0_IB ) then
       if ( IsShowOn == 1_IB ) then
          write (*,'(4x,a)') '[PROBLEMATIC] @@@@@@@@@@@@@@@@@@@@@@@@'
          write (*,'(4x,a)') '[SPLINE1DFor] Out of allowed range @@@'
          write (*,'(4x,a)') '[SPLINE1DFor] SPLINE1DFor set = 0.0 @@'
          write (w,'(e15.6)') x
          write (r,'(e15.6)') t(0)
          write (z,'(e15.6)') t(n-1)
          write (*,'(4x,a,a6,a,a6,a,a6)') '[SPLINE1DFor] ',trim(adjustl(w)),' => ',trim(adjustl(r)),' -- ',trim(adjustl(z))
       end if
    end if
    
    do i=n-1,0,-1
       diff = x - t(i)
       if (diff >= 0.0_RP) exit
    end do
    
    if ( i > n-2 ) then
       i = n-2
    end if
    if ( i < 0 ) then
       i = 0
    end if
    o = y(i) + (x - t(i))*(y(i+1) - y(i))/(t(i+1) - t(i))

    if ( IsShowOn == 1_IB ) then
       write (*,'(4x,a)') '[SPLINE1DFlt]'
       write (w,'(e15.8)') x
       write (z,'(e15.8)') o
       write (*,'(4x,a,a,a)') '... x: ',trim(adjustl(w))//' ==> y: ', &
            trim(adjustl(z))
       write (*,'(4x,a)') '[SPLINE1DFlt]'
    end if
    
    return
END SUBROUTINE SPLINE1DFlt
! ###########################################################################

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE author_SPLINE1Darr( a )
  use ModDataType

  implicit none
  
  character (len=21), intent(out) :: a

  !f2py intent(out) :: a

  a = 'Written by Jean Gomes'
  
END SUBROUTINE author_SPLINE1Darr
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Jean@Porto - Tue Sep 27 18:38:40 AZOST 2011 +++++++++++++++++++++++++++++++

! *** Test ******************************************************************
!PROGRAM GeneralTest
!END PROGRAM GeneralTest
! *** Test ******************************************************************
  
! *** Number : 001                                                          !

! ###########################################################################
!     RESUME : For a given array of values 'xx_value' for the               !
!              abscissa, then return the ordinate array values of           !
!              'yy_value' based on a linear interpolation within a          !
!              table of pair values [xold_vec, yold_vec].                   !
!                                                                           !
!     Input           arguments = 5                                         !
!     Output          arguments = 2                                         !
!     Optional        arguments = 2                                         !
!     Total number of arguments = 9                                         !
!                                                                           !
!     INPUT  : 01) xx_value  -> New interpolated x array with points        !
!              02) nxyvalue  -> # of elements in xx_value and yy_value      !
!              03) xold_vec  -> Old x vector (abcissas)                     !
!              04) yold_vec  -> Old y vector (ordenadas)                    !
!              05) nold_vec  -> # of elements in xold_vec and yold_vec      !
!              06) Is_Index  -> Search: Linear: [1] & Binary [0]            !
!              07) verbosity -> Print & Check screen                        !
!                                                                           !
!     OUTPUT : 01) yy_value -> New interpolated y array with points         !
!              02) IsKeepOn -> Flag, if == 0 then there's a problem         !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Wed May  2 10:00:52 WEST 2012                                !
!              Fri Dec 28 13:53:36 WET  2012                                !
!              Sun Mar 10 10:05:03 WET  2013                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE Interpolado( xx_value,yy_value,nxyvalue,xold_vec,yold_vec,       &
                        nold_vec,IsKeepOn,Is_Index,verbosity )
    use ModDataType
    implicit none

    ! Variable declarations
    integer  (kind=IB), intent(in) :: nold_vec,nxyvalue
    integer  (kind=IB), intent(out) :: IsKeepOn
    integer  (kind=IB) :: i,j,k,ii,jj,indices_,IsShowOn
    integer  (kind=IB), optional :: Is_Index,verbosity
    
    real     (kind=RP), dimension(0:nold_vec-1), intent(in)  :: xold_vec,yold_vec
    real     (kind=RP), dimension(0:nxyvalue-1), intent(in)  :: xx_value
    real     (kind=RP), dimension(0:nxyvalue-1), intent(out) :: yy_value
    
    !f2py real     (kind=RP), intent(in)  :: xx_value
    !f2py real     (kind=RP), intent(out) :: yy_value
    !f2py                     intent(hide), depend(xx_value) :: nxyvalue=shape(xx_value,0)
    !f2py                     intent(hide), depend(yy_value) :: nxyvalue=shape(yy_value,0)

    !f2py real     (kind=RP), intent(in) :: xold_vec
    !f2py real     (kind=RP), intent(in) :: yold_vec
    !f2py                     intent(hide), depend(xold_vec) :: nold_vec=shape(xold_vec,0)
    !f2py                     intent(hide), depend(yold_vec) :: nold_vec=shape(yold_vec,0)

    !f2py integer  (kind=IB), intent(out) :: IsKeepOn
    !f2py integer  (kind=IB), optional :: Is_Index=0
    !f2py integer  (kind=IB), optional :: verbosity=0

    if ( present(verbosity) ) then
        IsShowOn = verbosity
    else
        IsShowOn = 0_IB
    end if

    if ( present(Is_Index) ) then
       indices_ = Is_Index
    else
       indices_ = 0_IB
    end if

    IsKeepOn = 1_IB
    
    if ( IsShowOn == 1_IB ) then
       write (*,'(4x,a)') '[Interpolado]'
    end if

    if ( nold_vec < 1 ) then
       if ( IsShowOn == 1_IB ) then
          write (*,'(4x,a)') '[PROBLEM_INT] @@@@@@@@@@@@@@@@@@@@@@@@'
          write (*,'(4x,a)') '[Interpolado] nold_vec < 1 dimension @'
       end if
       yy_value = -999.0_RP    
       IsKeepOn = 0_IB
       return
    end if
    
    jj = 0
    do i=0,nxyvalue-1

       if ( indices_ == 1_IB ) then
          ! Linear Search
          do j=0,nold_vec-2
             if ( xx_value(i) >= xold_vec(j) .and.                          &
                  xx_value(i) <= xold_vec(j+1) ) then
                jj = j
                exit
             end if
          end do
       else
          ! Binary Search
          ii = 0
          if ( xx_value(i) > xold_vec(0) .and. xx_value(i) < xold_vec(nold_vec-1)  ) then
             ii = 0
             jj = nold_vec
             do while (jj > ii+1)
                k = (ii+jj)/2
                if (xx_value(i) < xold_vec(k)) then
                   jj=k
                else
                   ii=k
                end if
             end do
             jj = ii
          else if ( xx_value(i) <= xold_vec(0) ) then
             jj = 0
          else if ( xx_value(i) >= xold_vec(nold_vec-1) ) then
             jj = nold_vec-2
          end if
       end if

       if ( jj > nold_vec-2 ) then
          jj = nold_vec-2
       end  if
       if ( jj < 0 ) then
          jj = 0
       end  if
       
       yy_value(i) = yold_vec(jj)+(yold_vec(jj+1)-yold_vec(jj))             &
                   * (xx_value(i)-xold_vec(jj))/(xold_vec(jj+1)-xold_vec(jj))
    end do

    if ( IsShowOn == 1_IB ) then
       write (*,'(4x,a)') '[Interpolado]'
    end if

    return
END SUBROUTINE Interpolado
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE author_Interpolado( a )
  use ModDataType

  implicit none
  
  character (len=21), intent(out) :: a

  !f2py intent(out) :: a

  a = 'Written by Jean Gomes'
  
END SUBROUTINE author_Interpolado
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Jean@Porto - Tue Sep 27 18:38:40 AZOST 2011 +++++++++++++++++++++++++++++++

! *** Test ******************************************************************
!PROGRAM GeneralTest
!END PROGRAM GeneralTest
! *** Test ******************************************************************

! *** Number : 002                                                          !
!
! 1) Interpolado
! 2) author_Interpolado

! ###########################################################################
!     RESUME : Interpolation with cubic spline function. Evaluate the       !
!     coefficients b(i), c(i), and d(i), i=1,2,...,n for cubic spline       !
!     interpolation. In mathematics, a spline is a special function         !
!     defined piecewise by polynomials. In interpolating problems,          !
!     spline interpolation is often preferred to polynomial                 !
!     interpolation because it yields similar results, even when using      !
!     low degree polynomials, while avoiding Runge's phenomenon for         !
!     higher degrees.                                                       !
!                                                                           !
!              s(x) = y(i) + b(i)*(x-x(i))**1 + c(i)*(x-x(i))**2            !
!                          + d(i)*(x-x(i))**3                               !
!                                                                           !
!              For x(i) <= x <= x(i+1), strictly valid otherwise            !
!              extrapolate.                                                 !
!                                                                           !
!     Input           arguments = 3                                         !
!     Output          arguments = 4                                         !
!     Optional        arguments = 1                                         !
!     Total number of arguments = 8                                         !
!                                                                           !
!     INPUT  : 01) x         -> Old x vector (abcissas)                     !
!              02) y         -> Old y vector (ordenadas)                    !
!              03) n         -> # of elements in vector x and y             !
!              04) verbosity -> Print & Check screen                        !
!                                                                           !
!     OUTPUT : 01) b         -> Spline coefficient order 1                  !
!              02) c         -> Spline coefficient order 2                  !
!              03) d         -> Spline coefficient order 3                  !
!              04) IsKeepOn  -> Flag, if == 0 then there's a problem        !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     References :
!
!     1) Forsythe, G.E. (1977) Computer Methods For Mathematical
!     Computations. Ed. Prentice-Hall, Inc. Link:
!     https://www.abebooks.com/9780131653323/Computer-Methods-Mathematical-Computations-Prentice-Hall-0131653328/plp
!
!     2) De Boor, C. (1978). A Practical Guide to
!     Splines. Springer-Verlag. DOI: 10.1007/978-1-4757-0457-4. Link:
!     https://www.springer.com/gp/book/9780387953663
!
!     3) Smith, L. (1995). A cubic spline algorithm based on a modified
!     divided difference. Mathematics and Computers in Simulation, 39(3),
!     347-350. DOI: 10.1016/0378-4754(94)00122-8. Link:
!     https://www.sciencedirect.com/science/article/abs/pii/0378475494001228
!
!     4) Bartels, R.H., Beatty, J.C., and Barsky, B.A. (1998). An Introduction
!     to Splines for Use in Computer Graphics and Geometric Modeling. Morgan
!     Kaufmann Publishers. ISBN: 978-1558604000. Link:
!     https://www.elsevier.com/books/an-introduction-to-splines-for-use-in-computer-graphics-and-geometric-modeling/bartels/978-1-55860-400-0
!
!     5) Burden, R. L., & Faires, J. D. (2010). Numerical Analysis (9th
!     ed.). Brooks/Cole. ISBN: 978-0538733519. Link:
!     https://www.amazon.com/Numerical-Analysis-Richard-L-Burden/dp/0538733519
!
!     6) Press, W. H., Teukolsky, S. A., Vetterling, W. T., & Flannery,
!     B. P. (2007). Numerical Recipes: The Art of Scientific Computing (3rd
!     ed.). Cambridge University Press. ISBN: 978-0521880688. Link:
!     http://numerical.recipes/
!
!     7) Cheney, W. and Kincaid, D. (2008). Numerical Mathematics and
!     Computing (6th ed.). Brooks/Cole. ISBN: 978-0495114758. Link:
!     https://www.amazon.com/Numerical-Mathematics-Computing-Ward-Cheney/dp/0495114758
!
!     Written: Jean Michel Gomes                                            !
!     Checked: Tue May  1 16:09:13 WEST 2012                                !
!              Fri Dec 28 14:55:10 WET  2012                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE SPLINE3DCoe( x,y,b,c,d,n,IsKeepOn,verbosity )

    use ModDataType
    implicit none

    integer  (kind=IB), intent(in) :: n
    integer  (kind=IB), intent(out) :: IsKeepOn
    integer  (kind=IB), optional :: verbosity
    
    integer  (kind=IB) :: i,j,last,IsShowOn

    real     (kind=RP), intent(in), dimension(0:n-1) :: x,y
    real     (kind=RP), intent(out), dimension(0:n-1) :: b,c,d

    real     (kind=RP) :: h

    character (len=CH) :: W1aux
    
    !f2py real     (kind=RP), intent(in)  :: x,y
    !f2py                     intent(hide), depend(x) :: n=shape(x,0)
    !f2py                     intent(hide), depend(y) :: n=shape(y,0)

    !f2py real     (kind=RP), intent(out)  :: b,c,d
    !f2py                     intent(hide), depend(b) :: n=shape(b,0)
    !f2py                     intent(hide), depend(c) :: n=shape(c,0)
    !f2py                     intent(hide), depend(d) :: n=shape(d,0)

    !f2py integer  (kind=IB), intent(out) :: IsKeepOn
    !f2py integer  (kind=IB), optional :: verbosity=0

    intrinsic adjustl, min, trim
    
    if ( present(verbosity) ) then
       IsShowOn = verbosity
    else
       IsShowOn = 0_IB
    end if

    if ( IsShowOn == 1_IB  ) then
       write (*,'(4x,a)') '[SPLINE3DCoe]'
    end if
    
    last = n-2

! *** Check input values ****************************************************
    if ( n < 2 ) then
       IsKeepOn = 0_IB
       b        = -999.0_RP
       c        = -999.0_RP
       d        = -999.0_RP
       if ( IsShowOn == 1_IB  ) then
          write (*,'(4x,a)')  '[PROBLEM_FIT] @@@@@@@@@@@@@@@@@@@@@@@@'
          write (W1aux,'(i15)') n
          write (*,'(4x,a,a)') '... n < 2 ==',trim(adjustl(W1aux))
          write (*,'(4x,a)')   '... Set spline coefficients == -999 @'
       end if
       return
    end if

    if ( n < 3 ) then
       b(0) = (y(1)-y(0))/(x(1)-x(0))                                       ! A simple linear interpolation if less than 3 points
       c(0) = 0.0_RP
       d(0) = 0.0_RP
       b(1) = + b(0)
       c(1) = 0.0_RP
       d(1) = 0.0_RP
       return
    end if

! *** Part 1: Setup initial values ******************************************
    d(0) = (x(1) - x(0))
    c(1) = (y(1) - y(0))/d(0)

    do i=1,last
       d(i)   =        (x(i+1) - x(i))
       b(i)   = 2.0_RP*(d(i-1) + d(i))
       c(i+1) =        (y(i+1) - y(i))/d(i)
       c(i)   =        (c(i+1) - c(i))
    end do

! *** Part 2: Boundary conditions *******************************************
    b(0)   = -d(0)
    b(n-1) = -d(n-2)
    c(0)   = +0.0_RP
    c(n-1) = +0.0_RP

    if ( n /= 3 ) then
       c(0)   = +c(2)/(x(3)-x(1)) - c(1)/(x(2)-x(0))
       c(n-1) = +c(n-2)/(x(n-1)-x(n-3)) - c(n-3)/(x(n-2)-x(n-4))
       c(0)   = +c(0)*d(0)**2/(x(3)-x(0))
       c(n-1) = -c(n-1)*d(n-2)**2/(x(n-1)-x(n-4))
    end if

! *** Part 3: Forward elimination *******************************************
    do i=1,n-1
       h    = d(i-1)/b(i-1)
       b(i) = b(i) - h*d(i-1)
       c(i) = c(i) - h*c(i-1)
    end do

! *** 4: Back substitution **************************************************
    c(n-1) = c(n-1)/b(n-1)

    ! Indexes from 1 to n comparison
    ! j = 1   => i = n-1
    ! j = n-1 => i = n-(n-1) = 1
    ! Indexes from 0 to n-1 should be
    ! j = 0   => i = n-2
    ! j = n-2 => i = 0
    do j=0,last
       i    = n-(j+2)
       c(i) = (c(i) - d(i)*c(i+1))/b(i)
    end do

! *** Part 5: Compute spline coefficients ***********************************
!     RESUME: 3rd degree polynomial                                         !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    b(n-1) = (y(n-1) - y(last))/d(last) + d(last)*(c(last) + 2.0_RP*c(n-1)) !/ 3
    do i=0,last
       b(i) = (y(i+1) - y(i))/d(i) - d(i)*(c(i+1) + 2.0_RP*c(i))
       d(i) = (c(i+1) - c(i))/d(i)
       c(i) = 3.0_RP*c(i)
    end do
    c(n-1) = 3.0_RP*c(n-1)
    d(n-1) = d(n-2)

    if ( IsShowOn == 1_IB  ) then
       write (*,'(4x,a,10(e12.5))') '... b = ',(b(i),i=1,min(10,n))
       write (*,'(4x,a,10(e12.5))') '... c = ',(c(i),i=1,min(10,n))
       write (*,'(4x,a,10(e12.5))') '... d = ',(d(i),i=1,min(10,n))
       write (*,'(4x,a)') '[SPLINE3DCoe]'
    end if

    return
END SUBROUTINE SPLINE3DCoe
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! ###########################################################################
!     RESUME : This function evaluates the cubic spline interpolation       !
!              at point u, i.e.                                             !
!                                                                           !
!              I_SPLINE3D = y(i) + b(i)*(u-x(i))**1 + c(i)*(u-x(i))**2      !
!                         + d(i)*(u-x(i))**3                                !
!                                                                           !
!              Where x(i) <= u <= x(i+1)                                    !
!                                                                           !
!              The coefficients b(i), c(i), and d(i), i=1,2,...,n for       !
!              cubic spline interpolation is computed in the spline         !
!              subroutine.                                                  !
!                                                                           !
!     Input           arguments = 7                                         !
!     Output          arguments = 1                                         !
!     Optional        arguments = 0                                         !
!     Total number of arguments = 8                                         !
!                                                                           !
!     INPUT  : 01) u          -> New x value (abcissa)                      !
!              02) x          -> Old x vector (abcissas)                    !
!              03) y          -> Old y vector (ordenadas)                   !
!              04) b          -> Spline coefficient order 1                 !
!              05) c          -> Spline coefficient order 2                 !
!              06) d          -> Spline coefficient order 3                 !
!              07) n          -> # of elements in vector x and y            !
!                                                                           !
!     OUTPUT : 01) I_SPLINE3D -> Interpolated value at u                    !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Tue May  1 16:09:13 WEST 2012                                !
!              Fri Dec 28 14:55:10 WET  2012                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
REAL (KIND=RP) FUNCTION I_SPLINE3D( u,x,y,b,c,d,n )

    use ModDataType
    implicit none

    integer  (kind=IB), intent(in) :: n
    integer  (kind=IB) :: i,j,k
    real     (kind=RP), intent(in), dimension(0:n-1) :: b,c,d
    real     (kind=RP), intent(in), dimension(0:n-1) :: x,y
    real     (kind=RP), intent(in) :: u
    real     (kind=RP) :: dx

    !f2py real     (kind=RP), intent(in)  :: x,y
    !f2py                     intent(hide), depend(x) :: n=shape(x,0)
    !f2py                     intent(hide), depend(y) :: n=shape(y,0)

    !f2py real     (kind=RP), intent(in)  :: b,c,d
    !f2py                     intent(hide), depend(b) :: n=shape(b,0)
    !f2py                     intent(hide), depend(c) :: n=shape(c,0)
    !f2py                     intent(hide), depend(d) :: n=shape(d,0)
    
    !f2py real     (kind=RP), intent(in)  :: u
    !f2py real     (kind=RP), intent(out)  :: I_SPLINE3D
    
! *** Binary search for i, such that x(i) <= u <= x(i+1) ********************
    i = 0
    if ( u > x(0) .AND. u < x(n-1)  ) then
       i = 0
       j = n
       do while (j > i+1)
          k = (i+j)/2
          if (u < x(k)) then
             j=k
          else
             i=k
          end if
       end do

!       i = 1
!       j = n+1
!20     k = (i+j)/2
!       if ( u  < x(k) ) j = k
!       if ( u >= x(k) ) i = k
!       if ( j  > i+1  ) go to 20
       
    end if
! *** Binary search for i, such that x(i) <= u <= x(i+1) ********************
    
! *** if u is ouside the x interval take a boundary value (left or right) ***
    if ( u <= x(0) ) then
       i = 0
       !I_SPLINE3D = y(0)
       !return
    end if
    if ( u >= x(n-1) ) then
       i = n-1
       !I_SPLINE3D = y(n-1)
       !return
    end if
! *** if u is ouside the x interval take a boundary value (left or right) ***    
    
! *** Binary search for i, such that x(i) <= u <= x(i+1) ********************
    
! *** Evaluate spline interpolation *****************************************
    dx = u - x(i)
    I_SPLINE3D = y(i) + dx*(b(i) + dx*(c(i) + dx*d(i)))

    return
END FUNCTION I_SPLINE3D
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! ###########################################################################
!     RESUME : This function evaluates the cubic spline interpolation       !
!              at u (real value), i.e.                                      !
!                                                                           !
!              SPLINE3DFor = y(i) + b(i)*(u-x(i))**1 + c(i)*(u-x(i))**2     !
!                          + d(i)*(u-x(i))**3                               !
!                                                                           !
!              Where stricly valid from x(i) <= u <= x(i+1)                 !
!                                                                           !
!              The coefficients b(i), c(i), and d(i), i=1,2,...,n for       !
!              cubic spline interpolation is computed in the spline         !
!              subroutine.                                                  !
!                                                                           !                                                                           !
!     Input           arguments = 4                                         !
!     Output          arguments = 2                                         !
!     Optional        arguments = 1                                         !
!     Total number of arguments = 7                                         !
!                                                                           !
!     INPUT  : 01) u           -> New x value (abcissa)                     !
!              02) x           -> Old x vector (abcissas)                   !
!              03) y           -> Old y vector (ordenadas)                  !
!              04) n           -> # of elements in vector x and y           !
!              05) verbosity   -> Print & Check screen                      !
!                                                                           !
!     OUTPUT : 01) SPLINE3DFor -> Interpolated value of y at point u        !
!              02) IsKeepOn    -> Flag, if == 0 then there's a problem      !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Tue May  1 16:09:13 WEST 2012                                !
!              Fri Dec 28 14:55:10 WET  2012                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
REAL (KIND=RP) FUNCTION SPLINE3DFor( u,x,y,n,IsKeepOn,verbosity )
    use ModDataType
    implicit none

    integer  (kind=IB), intent(in) :: n
    integer  (kind=IB), intent(out) :: IsKeepOn
    integer  (kind=IB), optional :: verbosity
    integer  (kind=IB) :: IsShowOn
    real     (kind=RP), dimension(0:n-1) :: b,c,d
    real     (kind=RP), intent(in), dimension(0:n-1) :: x,y
    real     (kind=RP), intent(in) :: u

    !f2py real     (kind=RP), intent(in)  :: x,y
    !f2py                     intent(hide), depend(x) :: n=shape(x,0)
    !f2py                     intent(hide), depend(y) :: n=shape(y,0)

    !f2py real     (kind=RP), intent(in)  :: u
    !f2py real     (kind=RP), intent(out)  :: SPLINE3DFor

    !f2py integer  (kind=IB), intent(out) :: IsKeepOn
    !f2py integer  (kind=IB), optional :: verbosity=0

    interface
       subroutine SPLINE3DCoe( x,y,b,c,d,n,IsKeepOn,verbosity )
         use ModDataType
         integer  (kind=IB), intent(in) :: n
         integer  (kind=IB), intent(out) :: IsKeepOn
         integer  (kind=IB), optional :: verbosity
         real     (kind=RP), intent(in), dimension(0:n-1) :: x,y
         real     (kind=RP), intent(out), dimension(0:n-1) :: b,c,d
       end subroutine SPLINE3DCoe
       real (kind=RP) function I_SPLINE3D( u,x,y,b,c,d,n )
         use ModDataType
         integer  (kind=IB), intent(in) :: n
         real     (kind=RP), intent(in), dimension(0:n-1) :: b,c,d
         real     (kind=RP), intent(in), dimension(0:n-1) :: x,y
         real     (kind=RP), intent(in) :: u
       end function I_SPLINE3D
    end interface

    if ( present(verbosity) ) then
       IsShowOn = verbosity
    else
       IsShowOn = 0_IB
    end if
    
! --- First compute the coefficients ----------------------------------------
    call SPLINE3DCoe( x,y,b,c,d,n,IsKeepOn,IsShowOn )
! --- First compute the coefficients ----------------------------------------

! --- Compute the output value ----------------------------------------------
    SPLINE3DFor = I_SPLINE3D( u,x,y,b,c,d,n )
! --- Compute the output value ----------------------------------------------

    return
END FUNCTION SPLINE3DFor
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! ###########################################################################
!     RESUME : This function evaluates the cubic spline interpolation       !
!              for an array u (j going from 0 to m), i.e.                   !
!                                                                           !
!              SPLINE3DArr = y(i) + b(i)*(u(j)-x(i))**1                     !
!                                 + c(i)*(u(j)-x(i))**2                     !
!                                 + d(i)*(u(j)-x(i))**3                     !
!                                                                           !
!              Where stricly valid from x(i) <= u(j) <= x(i+1)              !
!                                                                           !
!              The coefficients b(i), c(i), and d(i), i=1,2,...,n for       !
!              cubic spline interpolation is computed in the spline         !
!              subroutine.                                                  !
!                                                                           !                                                                           !
!     Input           arguments = 5                                         !
!     Output          arguments = 2                                         !
!     Optional        arguments = 1                                         !
!     Total number of arguments = 8                                         !
!                                                                           !
!     INPUT  : 01) u           -> New x value (abcissa)                     !
!              02) m           -> # of elements in vector u and o           !
!              03) x           -> Old x vector (abcissas)                   !
!              04) y           -> Old y vector (ordenadas)                  !
!              05) n           -> # of elements in vector x and y           !
!              06) verbosity   -> Print & Check screen                      !
!                                                                           !
!     OUTPUT : 01) o           -> Interpolated array of ys at points u      !
!              02) IsKeepOn    -> Flag, if == 0 then there's a problem      !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Tue May  1 16:09:13 WEST 2012                                !
!              Fri Dec 28 14:55:10 WET  2012                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE SPLINE3DArr( u,o,m,x,y,n,IsKeepOn,verbosity )
    use ModDataType
    implicit none

    integer  (kind=IB), intent(in) :: n,m
    integer  (kind=IB), intent(out) :: IsKeepOn

    integer  (kind=IB) :: i,IsShowOn
    real     (kind=RP), dimension(0:n-1) :: b,c,d
    real     (kind=RP), intent(in), dimension(0:n-1) :: x,y

    real     (kind=RP), intent(in), dimension(0:m-1) :: u
    real     (kind=RP), intent(out), dimension(0:m-1) :: o

    integer  (kind=IB), optional :: verbosity

    character (len=CH) :: w,z

    !f2py real     (kind=RP), intent(in)  :: x,y
    !f2py                     intent(hide), depend(x) :: n=shape(x,0)
    !f2py                     intent(hide), depend(y) :: n=shape(y,0)

    !f2py real     (kind=RP), intent(in)  :: u
    !f2py                     intent(hide), depend(u) :: m=shape(u,0)

    !f2py real     (kind=RP), intent(out)  :: o
    !f2py                     intent(hide), depend(o) :: m=shape(o,0)

    !f2py integer  (kind=IB), intent(out) :: IsKeepOn
    !f2py integer  (kind=IB), optional :: verbosity=0

    intrinsic adjustl, trim
    
    interface
       subroutine SPLINE3DCoe( x,y,b,c,d,n,IsKeepOn,verbosity )
         use ModDataType
         integer  (kind=IB), intent(in) :: n
         integer  (kind=IB), intent(out) :: IsKeepOn
         integer  (kind=IB), optional :: verbosity
         real     (kind=RP), intent(in), dimension(0:n-1) :: x,y
         real     (kind=RP), intent(out), dimension(0:n-1) :: b,c,d
       end subroutine SPLINE3DCoe
       real (kind=RP) function I_SPLINE3D( u,x,y,b,c,d,n )
         use ModDataType
         integer  (kind=IB), intent(in) :: n
         real     (kind=RP), intent(in), dimension(0:n-1) :: b,c,d
         real     (kind=RP), intent(in), dimension(0:n-1) :: x,y
         real     (kind=RP), intent(in) :: u
       end function I_SPLINE3D
    end interface

    IsKeepOn = 1_IB

    if ( present(verbosity) ) then
       IsShowOn = verbosity
    else
       IsShowOn = 0
    end if
    
! --- First compute the coefficients ----------------------------------------
    call SPLINE3DCoe( x,y,b,c,d,n,IsKeepOn,IsShowOn )
! --- First compute the coefficients ----------------------------------------

! --- Compute the output value ----------------------------------------------
    if ( IsKeepOn == 1_IB ) then
       do i=0,m-1
          o(i)=I_SPLINE3D( u(i),x,y,b,c,d,n )

          if ( IsShowOn == 1_IB ) then
             if ( i == 0 ) then
                write (*,'(4x,a)') '[SPLINE3DArr]'
             end if
             write (w,'(e15.8)') x(i)
             write (z,'(e15.8)') o(i)
             write (*,'(4x,a,a,a)') '... x(i): ',trim(adjustl(w))//' ==> y: ', &
                  trim(adjustl(z))
             if ( i == m-1 ) then
                write (*,'(4x,a)') '[SPLINE3DArr]'
             end if
          end if
          
       end do
    else
       o = -999.0_RP
    end if
! --- Compute the output value ----------------------------------------------

END SUBROUTINE SPLINE3DArr
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE author_SPLINE3DFor( a )
  use ModDataType

  implicit none
  
  character (len=21), intent(out) :: a

  !f2py intent(out) :: a

  a = 'Written by Jean Gomes'
  
END SUBROUTINE author_SPLINE3DFor
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Jean@Porto - Tue Sep 27 18:38:40 AZOST 2011 +++++++++++++++++++++++++++++++

! *** Test ******************************************************************
!PROGRAM GeneralTest
!END PROGRAM GeneralTest
! *** Test ******************************************************************

! *** Number : 005                                                          !
!
! 1) SPLINE3DCoe
! 2) I_SPLINE3D
! 3) SPLINE3DFor
! 4) SPLINE3DArr
! 5) author_SPLINE3DFor

! ###########################################################################
!     RESUME : Akima Spline interpolation. The Akima spline is a C1         !
!     differentiable function (that is, has a continuous first derivative)  !
!     but, in general, will have a discontinuous second derivative at the   !
!     knot points.                                                          !
!                                                                           !
!     [1]: Akima, H. (1970). A New Method of Interpolation and Smooth Curve !
!          Fitting Based on Local Procedures. Journal of the ACM, 17(4),    !
!          589-602. Association for Computing                               !
!          Machinery. doi:10.1145/321607.321609                             !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Wed May  2 10:00:52 WEST 2012                                !
!              Fri Dec 28 13:53:36 WET  2012                                !
!              Sun Mar 10 10:05:03 WET  2013                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! ###########################################################################
!     RESUME : Absolute value function with small quadratic parabola-like   !
!              in the valley so that it is C1 continuous. C1 continuous     !
!              - Continuous first derivative.                               !
!                                                                           !
!     Input           arguments = 2                                         !
!     Output          arguments = 1                                         !
!     Optional        arguments = 0                                         !
!     Total number of arguments = 3                                         !
!                                                                           !
!     INPUT  : 01) x       -> Input value                                   !
!              02) delta_x -> Valley window point to be quadratic           !
!                                                                           !
!     OUTPUT : 01) y       -> Output value                                  !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Tue May  1 16:09:13 WEST 2012                                !
!              Fri Dec 28 14:55:10 WET  2012                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE ABS__smooth( x,y,delta_x )
    use ModDataType
    implicit none
    
    ! --- input data ---
    real     (kind=RP), intent(in) :: x, delta_x

    ! --- output data --
    real     (kind=RP), intent(out) :: y

    !f2py real     (kind=RP), intent(in) :: x
    !f2py real     (kind=RP), intent(out) :: y
    !f2py real     (kind=RP), intent(in) :: delta_x = 0.1
    
    if ( x >= delta_x ) then
       y = x
    else if ( x <= -delta_x ) then
       y = -x
    else
       y = x*x / (2.0_RP*delta_x) + delta_x / 2.0_RP
    end if 

END SUBROUTINE ABS__smooth
! ###########################################################################

! ###########################################################################
!     RESUME : Compute the Spline Coefficients for the Akima Spline         !
!              function.                                                    !
!                                                                           !
!     Input           arguments = 4                                         !
!     Output          arguments = 4                                         !
!     Optional        arguments = 0                                         !
!     Total number of arguments = 8                                         !
!                                                                           !
!     INPUT  : 01) xold_vec -> Original Abscissa                            !
!              02) yold_vec -> Original Ordinate                            !
!              03) nold_vec -> # of Points                                  !
!              04) delta__x -> Valley window point to be quadratic          !
!                                                                           !
!     OUTPUT : 01) p0       -> Spline Coefficient                           !
!              02) p1       -> Spline Coefficient                           !
!              03) p2       -> Spline Coefficient                           !
!              04) p3       -> Spline Coefficient                           !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Wed May  2 10:00:52 WEST 2012                                !
!              Fri Dec 28 13:53:36 WET  2012                                !
!              Sun Mar 10 10:05:03 WET  2013                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE Akima_Setup( xold_vec,yold_vec,nold_vec,p0,p1,p2,p3,delta__x )
    use ModDataType
    implicit none

    real     (kind=RP), parameter :: eps = 1.0e-30_RP

    ! --- input data ---
    integer  (kind=IB), intent(in) :: nold_vec
    real     (kind=RP), dimension(0:nold_vec-1), intent(in) :: xold_vec,    &
                                                               yold_vec     ! Original points
    real     (kind=RP), intent(in) :: delta__x

    ! --- output data --
    real     (kind=RP), dimension(0:nold_vec-2), intent(out) :: p0, p1, p2, &
                                                                p3          ! Spline Coefficients

    ! --- local variables 
    integer  (kind=IB) :: i!,j
    real     (kind=RP), dimension(-2:nold_vec) :: m
    real     (kind=RP), dimension(0:nold_vec-1) :: t
    real     (kind=RP) :: m1, m2, m3, m4, w1, w2
    real     (kind=RP) :: t1, t2, dx

    !f2py real     (kind=RP), intent(in) :: xold_vec,yold_vec
    !f2py                     intent(hide), depend(xold_vec) :: n=shape(xold_vec,0)
    !f2py                     intent(hide), depend(yold_vec) :: n=shape(yold_vec,0)

    !f2py real     (kind=RP), intent(out) :: p0,p1,p2,p3
    !f2py                     intent(hide), depend(p0) :: m=shape(p0,0)
    !f2py                     intent(hide), depend(p1) :: m=shape(p1,0)
    !f2py                     intent(hide), depend(p2) :: m=shape(p2,0)
    !f2py                     intent(hide), depend(p3) :: m=shape(p3,0)
    
    !f2py real     (kind=RP), intent(in) :: delta__x = 0.1

    ! --- Compute Slope Segments ---
    do i=0,nold_vec-2
       !if ( xold_vec(i+1) /= xold_vec(i) ) then
       m(i) = (yold_vec(i+1) - yold_vec(i)) / (xold_vec(i+1) - xold_vec(i))
       !else
       !   if ( i > 1 ) then
       !      m(i) = m(i-1)
       !   end if
       !   if ( i == 1 .and. i+2<nold_vec-1 ) then
       !      j = i+1
       !      do while ( j < nold_vec-1 .and. xold_vec(j) == xold_vec(i) )
       !         j=j+1
       !         m(i) = (yold_vec(j) - yold_vec(i)) / (xold_vec(j) - xold_vec(i))
       !      end do
       !   end if
       !end if
    end do

    ! --- Estimation for end points
    m(0       -1) = 2.0_RP * m(0       +0) - m(0       +1)
    m(0       -2) = 2.0_RP * m(0       -1) - m(0       +0)
    m(nold_vec-1) = 2.0_RP * m(nold_vec-2) - m(nold_vec-3)
    m(nold_vec+0) = 2.0_RP * m(nold_vec-1) - m(nold_vec-2)

    ! --- Slope at points
    do i=0,nold_vec-1
       m1 = m(i-2)
       m2 = m(i-1)
       m3 = m(i)
       m4 = m(i+1)

!       w1 = abs(m4 - m3)
!       w2 = abs(m2 - m1)

       call ABS__smooth( m4 - m3, w1, delta__x )
       call ABS__smooth( m2 - m1, w2, delta__x )

       if ( w1 < eps .and. w2 < eps ) then
          t(i) = 0.5_RP*(m2 + m3)                                           ! --- Avoid division by zero
       else
          t(i) = (w1*m2 + w2*m3) / (w1 + w2)
       end if
    end do

! --- Compute Polynomial Cofficients ----------------------------------------
    do i=0,nold_vec-2
       dx    = xold_vec(i+1) - xold_vec(i)
       t1    = t(i)
       t2    = t(i+1)
       p0(i) = yold_vec(i)
       p1(i) = t1
       p2(i) = (3.0_RP*m(i) - 2.0_RP*t1 - t2)/dx
       !p3(i) = (t1 + t2 - 2.0_RP*m(i))/dx**2
       p3(i) = (t1 + t2 - 2.0_RP*m(i))/(dx*dx)
    end do
! --- Compute Polynomial Cofficients ----------------------------------------
    
    return
END SUBROUTINE Akima_Setup
! ###########################################################################

! ###########################################################################
!     RESUME : Evaluate the Akima Spline and its derivatives.  The          !
!              Akima spline is a C1 differentiable unction (that is,        !
!              has a continuous first derivative) but, in general,          !
!              will have a discontinuous second derivative at the knot      !
!              points.                                                      !
!                                                                           !
!     Input           arguments = 16                                        !
!     Output          arguments = 4                                         !
!     Optional        arguments = 1                                         !
!     Total number of arguments = 21                                        !
!                                                                           !
!     INPUT  : 01) xx_value -> New interpolated x array with points         !
!              02) nxyvalue -> # of elements in xx_value and yy_value       !
!              03) xold_vec -> Old x vector (abcissas)                      !
!              04) nold_vec -> # of elements in xold_vec and yold_vec       !
!              05) p0       -> Spline Coefficient                           !
!              06) p1       -> Spline Coefficient                           !
!              07) p2       -> Spline Coefficient                           !
!              08) p3       -> Spline Coefficient                           !
!              09) dp0dxold -> Derivatives of coefficients                  !
!              10) dp1dxold -> Derivatives of coefficients                  !
!              11) dp2dxold -> Derivatives of coefficients                  !
!              12) dp3dxold -> Derivatives of coefficients                  !
!              13) dp0dyold -> Derivatives of coefficients                  !
!              14) dp1dyold -> Derivatives of coefficients                  !
!              15) dp2dyold -> Derivatives of coefficients                  !
!              16) dp3dyold -> Derivatives of coefficients                  !
!              17) Is_Deriv -> Is derivative on:1 or off:0                  !
!              18) Is_Index -> Search: Linear: [1] & Binary [0]             !
!                                                                           !
!     OUTPUT : 01) yy_value -> New interpolated yy_value array              !
!              02) dy____dx -> Derivative of yy_value w.r.t. xx_value       !
!              03) dy_dxold -> Derivative of yy_value w.r.t. yold_vec       !
!              04) dy_dyold -> Derivative of yy_value w.r.t. yold_vec       !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Wed May  2 10:00:52 WEST 2012                                !
!              Fri Dec 28 13:53:36 WET  2012                                !
!              Sun Mar 10 10:05:03 WET  2013                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE Akimainterp( xx_value,yy_value,nx_value,xold_vec,nold_vec,p0,p1, &
                        p2,p3   ,dp0dxold,dp1dxold,dp2dxold,dp3dxold,       &
                        dp0dyold,dp1dyold,dp2dyold,dp3dyold,dy____dx,       &
                        dy_dxold,dy_dyold,Is_Deriv,Is_Index )
    use ModDataType
    implicit none
    
    ! --- input data ---
    integer  (kind=IB), intent(in) :: nold_vec
    integer  (kind=IB), intent(in) :: nx_value
    integer  (kind=IB), optional :: Is_Deriv,Is_Index

    real     (kind=RP), dimension(0:nold_vec-1), intent(in) :: xold_vec     ! Original x (abscissa) points
    real     (kind=RP), dimension(0:nold_vec-2), intent(in) :: p0,p1,p2,p3  ! Spline Coefficients

    real     (kind=RP), dimension(0:nx_value-1), intent(in) :: xx_value     ! New x values to evaluate y
    real     (kind=RP), dimension(0:nold_vec-2,0:nold_vec-1), intent(in) :: &
                                                                  dp0dxold, &
                                                                  dp1dxold, &
                                                                  dp2dxold, &
                                                                  dp3dxold
    real     (kind=RP), dimension(0:nold_vec-2,0:nold_vec-1), intent(in) :: &
                                                                  dp0dyold, &
                                                                  dp1dyold, &
                                                                  dp2dyold, &
                                                                  dp3dyold
    
    ! --- output data --
    real     (kind=RP), dimension(0:nx_value-1), intent(out) :: yy_value         ! New interpolated y values
    real     (kind=RP), dimension(0:nx_value-1), intent(out) :: dy____dx         ! Derivative of yy_values with respect to xx_values (new values)
    real     (kind=RP), dimension(0:nx_value-1,0:nold_vec-1), intent(out) ::&
                                                                  dy_dxold, &
                                                                  dy_dyold       ! Derivatives of yy_value with respect to xold_vec and yold_vec

    ! --- local variables
    integer  (kind=IB) :: i, j, k
    integer  (kind=IB) :: ii, jj, Derivatives, indice
    real     (kind=RP) :: dx,dx2,dx3

    !f2py real     (kind=RP), intent(in) :: xold_vec,yold_vec
    !f2py                     intent(hide), depend(xold_vec) :: nold_vec=shape(xold_vec,0)
    !f2py                     intent(hide), depend(yold_vec) :: nold_vec=shape(yold_vec,0)

    !f2py real     (kind=RP), intent(in) :: xx_value
    !f2py                     intent(hide), depend(xx_value) :: nxyvalue=shape(xx_value,0)
    
    !f2py real     (kind=RP), intent(out) :: yy_value
    !f2py                     intent(hide), depend(yy_value) :: nxyvalue=shape(yy_value,0)

    !f2py real     (kind=RP), intent(in) :: p0,p1,p2,p3
    !f2py                     intent(hide), depend(p0) :: m=shape(p0,0)
    !f2py                     intent(hide), depend(p1) :: m=shape(p1,0)
    !f2py                     intent(hide), depend(p2) :: m=shape(p2,0)
    !f2py                     intent(hide), depend(p3) :: m=shape(p3,0)

    !f2py real     (kind=RP), intent(in) :: dp0dxold
    !f2py real     (kind=RP), intent(in) :: dp1dxold
    !f2py real     (kind=RP), intent(in) :: dp2dxold
    !f2py real     (kind=RP), intent(in) :: dp3dxold
    !f2py real     (kind=RP), intent(in) :: dp0dyold
    !f2py real     (kind=RP), intent(in) :: dp1dyold
    !f2py real     (kind=RP), intent(in) :: dp2dyold
    !f2py real     (kind=RP), intent(in) :: dp3dyold

    !f2py                     intent(hide), depend(dp0dxold) :: m=shape(dp0dxold,0), nold_vec=shape(dp0dxold,1)
    !f2py                     intent(hide), depend(dp1dxold) :: m=shape(dp1dxold,0), nold_vec=shape(dp1dxold,1)
    !f2py                     intent(hide), depend(dp2dxold) :: m=shape(dp2dxold,0), nold_vec=shape(dp2dxold,1)
    !f2py                     intent(hide), depend(dp3dxold) :: m=shape(dp3dxold,0), nold_vec=shape(dp3dxold,1)
    !f2py                     intent(hide), depend(dp0dyold) :: m=shape(dp0dyold,0), nold_vec=shape(dp0dyold,1)
    !f2py                     intent(hide), depend(dp1dyold) :: m=shape(dp1dyold,0), nold_vec=shape(dp1dyold,1)
    !f2py                     intent(hide), depend(dp2dyold) :: m=shape(dp2dyold,0), nold_vec=shape(dp2dyold,1)
    !f2py                     intent(hide), depend(dp3dyold) :: m=shape(dp3dyold,0), nold_vec=shape(dp3dyold,1)

    
    !f2py real     (kind=RP), intent(out) :: dy____dx
    !f2py                     intent(hide), depend(dy____dx) :: nx_value=shape(dp0dxold,0)
    
    !f2py real     (kind=RP), intent(out) :: dy_dxold
    !f2py real     (kind=RP), intent(out) :: dy_dyold
    !f2py                     intent(hide), depend(dy_dxold) :: nx_value=shape(dy_dxold,0), nold_vec=shape(dy_dxold,1)
    !f2py                     intent(hide), depend(dy_dyold) :: nx_value=shape(dy_dyold,0), nold_vec=shape(dy_dyold,1)
    
    !f2py integer  (kind=IB), optional :: Is_Deriv=0
    !f2py integer  (kind=IB), optional :: Is_Index=0

    
    if ( present(Is_Deriv) ) then
       Derivatives = Is_Deriv 
    else
       Derivatives = 0_IB
    end if

    if ( present(Is_Index) ) then
       indice = Is_Index
    else
       indice = 0_IB
    end if

    !if ( Derivatives == 0_IB ) then
    !   dy____dx = 0.0_RP
    !   dy_dxold = 0.0_RP
    !   dy_dyold = 0.0_RP
    !end if
    
! --- Interpolate at each new point x ---------------------------------------
    j = 0
    do i=0,nx_value-1

! --- Find indexes in arrays ------------------------------------------------

! --- Use initial or end segments if outside boundaries / extrapolate -------
       if ( xx_value(i) <= xold_vec(0) ) then
          j = 0
       end if

       if ( xx_value(i) >= xold_vec(nold_vec-1) ) then
          j = nold_vec-2
       end if

       if ( indice == 1_IB ) then
          ! Normal Search
          if ( xx_value(i) > xold_vec(0) .and. &
               xx_value(i) < xold_vec(nold_vec-1) ) then
             ! linear search for now
             do j = nold_vec-2,1,-1
                if ( xx_value(i) >= xold_vec(j) ) then
                   exit
                end if
             end do
          end if
       else
          ! Binary Search
          if ( xx_value(i) > xold_vec(0) .and.                              &
               xx_value(i) < xold_vec(nold_vec-1) ) then
             ii = 0
             jj = nold_vec
             do while (jj > ii+1)
                k = (ii+jj)/2
                if (xx_value(i) < xold_vec(k)) then
                   jj=k
                else
                   ii=k
                end if
             end do
             !       i = 1
             !       j = n+1
             !20     k = (i+j)/2
             !       if ( u  < xx_value(K) ) j = k
             !       if ( u >= xx_value(K) ) i = k
             !       if ( j  > i+1  ) go to 20
             j = ii
          end if
          !write (*,*) j
       end if

       ! --- Evaluate polynomials and derivatives ---
       dx      = xx_value(i) - xold_vec(j)
       dx2     = dx  * dx
       dx3     = dx2 * dx
       
       !yy_value(i) = p0(j) + p1(j)*dx + p2(j)*dx**2 + p3(j)*dx**3
       !dy____dx(i) = p1(j) + 2.0_RP*p2(j)*dx + 3.0_RP*p3(j)*dx**2
       
       yy_value(i) = p0(j) + p1(j)*dx + p2(j)*dx2 + p3(j)*dx3

       ! *** Compute derivatives
       if ( Derivatives == 1_IB ) then
          dy____dx(i) = p1(j) + 2.0_RP*p2(j)*dx + 3.0_RP*p3(j)*dx2
          do k=0,nold_vec-1

             !dy_dxold(i,k) = dp0dxold(j,k) + dp1dxold(j,k)*dx              &
             !              + dp2dxold(j,k)*dx**2&
             !              + dp3dxold(j,k)*dx**3
             dy_dxold(i,k) = dp0dxold(j,k) + dp1dxold(j,k)*dx               &
                           + dp2dxold(j,k)*dx2                              &
                           + dp3dxold(j,k)*dx3

             if ( k == j ) then
                dy_dxold(i,k) = dy_dxold(i,k) - dy____dx(i)
             end if

             !dy_dyold(i,k) = dp0dyold(j,k) + dp1dyold(j,k)*dx              &
             !              + dp2dyold(j,k)*dx**2&
             !              + dp3dyold(j,k)*dx**3

             dy_dyold(i,k) = dp0dyold(j,k) + dp1dyold(j,k)*dx               &
                           + dp2dyold(j,k)*dx2 + dp3dyold(j,k)*dx3
          end do
       end if

    end do
! --- Interpolate at each new point x ---------------------------------------

    return
END SUBROUTINE Akimainterp
! ###########################################################################

! ###########################################################################
!     RESUME : For a given array of values 'xx_value' for the               !
!              abscissa, then return the ordinate array values of           !
!              'yy_value' based on Akima Spline interpolation.              !
!                                                                           !
!     INPUT  : 01) xx_value  -> New interpolated x array with points        !
!              02) nxyvalue  -> # of elements in xx_value and yy_value      !
!              03) xold_vec  -> Old x vector (abcissas)                     !
!              04) yold_vec  -> Old y vector (ordenadas)                    !
!              05) nold_vec  -> # of elements in xold_vec and yold_vec      !
!              06) delta__x  -> Value used in the absolute value function   !
!                               with small quadratic parabola-like in the   !
!                               valley so that it is C1 continuous. C1      !
!                               continuous                                  !
!              07) verbosity -> Print & Check screen                        !
!                                                                           !
!     OUTPUT : 01) yy_value -> New interpolated y array with points         !
!              02) IsKeepOn -> Flag, if == 0 then there's a problem         !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Wed May  2 10:00:52 WEST 2012                                !
!              Fri Dec 28 13:53:36 WET  2012                                !
!              Sun Mar 10 10:05:03 WET  2013                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE AkimaSpline( xx_value,yy_value,nxyvalue,xold_vec,yold_vec,       &
                        nold_vec,delta__x,IsKeepOn,verbosity )

    use ModDataType
    implicit none

    integer  (kind=IB), intent(in) :: nold_vec, nxyvalue
    integer  (kind=IB), optional :: verbosity
    integer  (kind=IB) :: IsShowOn,Is_Deriv,Is_Index

    integer  (kind=IB), intent(out) :: IsKeepOn
    
    real     (kind=RP), dimension(0:nold_vec-1), intent(in)  :: xold_vec,   &
                                                                yold_vec
    real     (kind=RP), dimension(0:nxyvalue-1), intent(in)  :: xx_value
    real     (kind=RP), dimension(0:nxyvalue-1), intent(out) :: yy_value

    real     (kind=RP), dimension(0:nold_vec-2,0:nold_vec-1) :: zero_vec

    real     (kind=RP), dimension(0:nxyvalue-1) :: dy_dxnew                 ! Derivative of yy_value with respect to xx_value
    real     (kind=RP), dimension(0:nxyvalue-1,0:nold_vec-1) :: dy_dxold,   &
                                                                dy_dyold    ! Derivative of yold_vec with respect to xold_vec and yold_vec


    real     (kind=RP), dimension(0:nold_vec-2) :: p0, p1, p2, p3           ! Spline Coefficients
    real     (kind=RP), intent(in) :: delta__x

    !f2py real     (kind=RP), intent(in) :: xold_vec,yold_vec
    !f2py                     intent(hide), depend(xold_vec) :: nold_vec=shape(xold_vec,0)
    !f2py                     intent(hide), depend(yold_vec) :: nold_vec=shape(yold_vec,0)

    !f2py real     (kind=RP), intent(in) :: xx_value
    !f2py                     intent(hide), depend(xx_value) :: nxyvalue=shape(xx_value,0)
    
    !f2py real     (kind=RP), intent(out) :: yy_value
    !f2py                     intent(hide), depend(yy_value) :: nxyvalue=shape(yy_value,0)

    !f2py real     (kind=RP), intent(in) :: delta__x = 0.1
    !f2py integer  (kind=IB), optional :: verbosity=0

    interface
       subroutine Akimainterp( xx_value,yy_value,nx_value,xold_vec,nold_vec,&
                               p0,p1,p2,p3,dp0dxold,dp1dxold,dp2dxold,      &
                               dp3dxold,dp0dyold,dp1dyold,dp2dyold,dp3dyold,&
                               dy____dx,dy_dxold,dy_dyold,Is_Deriv,Is_Index )
         use ModDataType
         integer  (kind=IB), intent(in) :: nold_vec
         integer  (kind=IB), intent(in) :: nx_value
         integer  (kind=IB), optional :: Is_Deriv,Is_Index
         real     (kind=RP), dimension(0:nold_vec-1), intent(in) :: xold_vec          ! Original x (abscissa) points
         real     (kind=RP), dimension(0:nold_vec-2), intent(in) :: p0,p1,  &
                                                                    p2,p3             ! Spline Coefficients
         real     (kind=RP), dimension(0:nx_value-1), intent(in) :: xx_value          ! New x values to evaluate y
         real     (kind=RP), dimension(0:nold_vec-2,0:nold_vec-1),          &
                                                            intent(in) ::   &
                                                            dp0dxold,       &
                                                            dp1dxold,       &
                                                            dp2dxold,       &
                                                            dp3dxold
         real     (kind=RP), dimension(0:nold_vec-2,0:nold_vec-1),          &
                                                            intent(in) ::   &
                                                            dp0dyold,       &
                                                            dp1dyold,       &
                                                            dp2dyold,       &
                                                            dp3dyold
         real     (kind=RP), dimension(0:nx_value-1), intent(out) :: yy_value         ! New interpolated y values
         real     (kind=RP), dimension(0:nx_value-1), intent(out) :: dy____dx         ! Derivative of y with respect to x (new values)
         real     (kind=RP), dimension(0:nx_value-1,0:nold_vec-1),          &
                                                              intent(out) ::&
                                                            dy_dxold,       &
                                                            dy_dyold                  ! Derivatives of y with respect to xold and yold

       end subroutine Akimainterp
    end interface

    IsKeepOn = 1_IB
    
    if ( present(verbosity) ) then
        IsShowOn = verbosity
    else
        IsShowOn = 0_IB
    end if

    if ( IsShowOn == 1_IB ) then
       write (*,'(4x,a)') '[AkimaSpline]'
    end if

    !if ( count(xold_vec(1:nold_vec-1)-xold_vec(0:nold_vec-2) < 0) > 0 ) then
    !   if ( IsShowOn == 1_IB ) then
    !      write (*,'(4x,a)') '... Houston, We have a problem'
    !   end if
    !   yy_value = -999.0_RP
    !   IsKeepOn = 0_IB
    !   return
    !end if
    !
    !if ( count(xold_vec(1:nold_vec-1)-xold_vec(0:nold_vec-2) == 0) > 0 ) then
    !   do i=0,nold_vec-2
    !      if ( xold_vec(i) == xold_vec(i+1) ) then
    !         !write (*,*) xold_vec(i),xold_vec(i+1)
    !         !write (*,*) yold_vec(i),yold_vec(i+1)
    !
    !         if ( yold_vec(i) /= yold_vec(i+1) ) then
    !            IsKeepOn = 0_IB
    !            return
    !         end if
    !      end if
    !   end do
    !
    !end if
    
    !delta__x = 0.0_RP
    call Akima_Setup( xold_vec,yold_vec,nold_vec,p0,p1,p2,p3,delta__x )

    !zero_vec = 0.0_RP
    Is_Deriv = 0_IB
    Is_Index = 0_IB
    call Akimainterp( xx_value,yy_value,nxyvalue,xold_vec,nold_vec,p0,p1,  &
                      p2,p3   ,zero_vec,zero_vec,zero_vec,zero_vec,        &
                      zero_vec,zero_vec,zero_vec,zero_vec,dy_dxnew,        &
                      dy_dxold,dy_dyold,Is_Deriv,Is_Index )

    if ( IsShowOn == 1_IB ) then
       write (*,'(4x,a)') '[AkimaSpline]'
    end if
    
    return

END SUBROUTINE AkimaSpline
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE author_AkimaSpline( a )
  use ModDataType

  implicit none
  
  character (len=21), intent(out) :: a

  !f2py intent(out) :: a

  a = 'Written by Jean Gomes'
  
END SUBROUTINE author_AkimaSpline
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Jean@Porto - Tue Sep 27 18:38:40 AZOST 2011 +++++++++++++++++++++++++++++++

! *** Test ******************************************************************
!PROGRAM test
!END PROGRAM test
! *** Test ******************************************************************

! *** Number : 005                                                          !
!
! 1) ABS__smooth
! 2) Akima_Setup
! 3) Akimainterp
! 4) AkimaSpline
! 5) author_AkimaSpline

! ###########################################################################
!     RESUME : Spline1DArr subroutine is written in fortran 2003            !
!              standard. It takes an array of values x to                   !
!              interpolate from the arrays t and y.                         !
!                                                                           !
!     Input           arguments = 6                                         !
!     Output          arguments = 2                                         !
!     Optional        arguments = 2                                         !
!     Total number of arguments = 10                                        !
!                                                                           !
!     INPUT  : 01) x        -> Interpolate into x array                     !
!              02) m        -> # of array elements in vector x and o        !
!              03) t        -> x vector (abcissas)                          !
!              04) y        -> y vector (ordenadas)                         !
!              05) n        -> # of array elements in vector t and y        !
!              06) e        -> epsilon machine dependent error              !
!              07) Is_Index -> Search: Linear: [1] & Binary [0]             !
!              08) k        -> Print & Check screen (OLD fortran way)       !
!                                                                           !
!     OUTPUT : 01) o        -> Interpolated y array                         !
!              02) IsKeepOn -> Flag, if == 0 then there's a problem         !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!        Date: Sun Oct 15 10:00:52 WEST 2006                                !
!     Checked: Tue May  1 16:09:13 WEST 2012                                !
!              Fri Dec 28 14:55:10 WET  2012                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE SPLINE1DArr( x,o,m,t,y,n,e,IsKeepOn,Is_Index,verbosity )

    use ModDataType

    implicit none
    integer  (kind=IB), intent(in) :: n,m
    integer  (kind=IB), intent(out) :: IsKeepOn
    integer  (kind=IB), optional :: Is_Index,verbosity
    integer  (kind=IB) :: i,j,k,IsShowOn
    integer  (kind=IB) :: ii,jj,indices_
    real     (kind=RP), intent(in), dimension(0:n-1)  :: t,y
    real     (kind=RP), intent(in), dimension(0:m-1)  :: x

    real     (kind=RP), intent(out), dimension(0:m-1) :: o
    
    real     (kind=RP), optional :: e

    real     (kind=RP) :: diff, epsilon
    character (len=CH) :: w,z,r

    !f2py real     (kind=RP), intent(in) :: t,y
    !f2py                     intent(hide), depend(t) :: n=shape(t,0)
    !f2py                     intent(hide), depend(y) :: n=shape(y,0)

    !f2py real     (kind=RP), intent(in) :: x
    !f2py                     intent(hide), depend(x) :: m=shape(x,0)

    !f2py real     (kind=RP), intent(out) :: o
    !f2py                     intent(hide), depend(o) :: m=shape(o,0)

    !f2py integer  (kind=IB), intent(out) :: IsKeepOn
    
    !f2py real     (kind=RP), intent(in), optional :: e=1.0e-8
    !f2py                     intent(in), optional :: Is_Index=0
    !f2py                     intent(in), optional :: verbosity=0
    
    intrinsic adjustl, count, present, trim

    if ( present(verbosity) ) then
       IsShowOn = verbosity
    else
       IsShowOn = 0_IB
    end if

    if ( present(Is_Index) ) then
       indices_ = Is_Index
    else
       indices_ = 0_IB
    end if

    IsKeepOn = 1_IB
    if ( n < 1 ) then
       if ( IsShowOn == 1_IB ) then
          write (*,'(4x,a)') '[PROBLEM_INT] @@@@@@@@@@@@@@@@@@@@@@@@'
          write (*,'(4x,a)') '[SPLINE1DArr] n < 1 dimension @@@@@@@@'
       end if
       o        = -999.0_RP    
       IsKeepOn = 0_IB
       return
    end if
    
    if ( present(e) ) then
       if ( e > 0.0_RP ) then
          epsilon = e
       else
          epsilon = 1.0e-8_RP
       end if
    else
       epsilon = 1.0e-8_RP
    end if

    i = 0
    do j=0,m-1
    
       if ( IsShowOn == 1_IB ) then
          if ( count(t(0:n-1) >= x(j) - epsilon) == 0_IB ) then
             write (*,'(4x,a)') '[PROBLEMATIC] @@@@@@@@@@@@@@@@@@@@@@@@'
             write (*,'(4x,a)') '[SPLINE1DArr] Out of allowed range @@@'
             write (*,'(4x,a)') '[SPLINE1DArr] SPLINE1DArr set = 0.0 @@'
             write (w,'(e15.6)') x(j)
             write (r,'(e15.6)') t(0)
             write (z,'(e15.6)') t(n-1)
             write (*,'(4x,a,a6,a,a6,a,a6)') '[SPLINE1DArr] ',trim(adjustl(w)),' => ',trim(adjustl(r)),' -- ',trim(adjustl(z))
             ! Removed the zero values !
             !o(j) = 0.0_RP
          else if ( count(t(0:n-1) <= x(j) + epsilon) == 0_IB ) then
             write (*,'(4x,a)') '[PROBLEMATIC] @@@@@@@@@@@@@@@@@@@@@@@@'
             write (*,'(4x,a)') '[SPLINE1DArr] Out of allowed range @@@'
             write (*,'(4x,a)') '[SPLINE1DArr] SPLINE1DArr set = 0.0 @@'
             write (w,'(e15.6)') x(j)
             write (r,'(e15.6)') t(0)
             write (z,'(e15.6)') t(n-1)
             write (*,'(4x,a,a6,a,a6,a,a6)') '[SPLINE1DArr] ',trim(adjustl(w)),' => ',trim(adjustl(r)),' -- ',trim(adjustl(z))
             ! Removed the zero values !
             !o(j) = 0.0_RP
          end if
       end if

       if ( indices_ == 0_IB ) then
! *** Binary search for i, such that x(i) <= u <= x(i+1) ********************
          !i = 0
          ii = 0
          if ( x(j) > t(0) .AND. x(j) < t(n-1)  ) then
             ii = 0
             jj = n
             do while (jj > ii+1)
                k = (ii+jj)/2
                if (x(j) < t(k)) then
                   jj=k
                else
                   ii=k
                end if
             end do
             i = ii
          else if ( x(j) <= t(0) ) then
             i = 0
          else if ( x(j) >= t(n-1) ) then
             i = n-2
          end if
! *** Binary search for i, such that x(i) <= u <= x(i+1) ********************

       else
! *** Normal Linear Search **************************************************
          do i=n-1,0,-1
             diff = x(j) - t(i)
             if (diff >= 0.0_RP) exit
          end do
! *** Normal Linear Search **************************************************
       end if
    
       if ( i > n-2 ) then
          i = n-2
       end if
       if ( i < 0 ) then
          i = 0
       end if

       !write (*,*) i
          
       o(j) = y(i) + (x(j) - t(i))*(y(i+1) - y(i))/(t(i+1) - t(i))
       !end if

       if ( IsShowOn == 1_IB ) then
          if ( j == 0) then
             write (*,'(4x,a)') '[SPLINE1DArr]'
          end if
          write (w,'(e15.8)') x(j)
          write (z,'(e15.8)') o(j)
          write (*,'(4x,a,a,a)') '... x(j): ',trim(adjustl(w))//' ==> y: ', &
               trim(adjustl(z))
          if ( j == m-1 ) then
             write (*,'(4x,a)') '[SPLINE1DArr]'
          end if
       end if

    end do

    return
END SUBROUTINE SPLINE1DArr
! ###########################################################################

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE author_SPLINE1Darr( a )
  use ModDataType

  implicit none
  
  character (len=21), intent(out) :: a

  !f2py intent(out) :: a

  a = 'Written by Jean Gomes'
  
END SUBROUTINE author_SPLINE1Darr
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Jean@Porto - Tue Sep 27 18:38:40 AZOST 2011 +++++++++++++++++++++++++++++++

! *** Test ******************************************************************
!PROGRAM GeneralTest
!END PROGRAM GeneralTest
! *** Test ******************************************************************
  
! *** Number : 002                                                          !
!
! 1) SPLINE1DArr
! 2) author_SPLINE1Darr

! ###########################################################################
!     RESUME : For a given array of values 'xx_value' for the               !
!              abscissa, then return the ordinate array values of           !
!              'yy_value' based on a linear interpolation within a          !
!              table of pair values [xold_vec, yold_vec]. This              !
!              subroutine assumes that the values in the array              !
!              xold_vec increases monotonically with yold_vec.              !
!                                                                           !
!     Input           arguments = 5                                         !
!     Output          arguments = 2                                         !
!     Optional        arguments = 1                                         !
!     Total number of arguments = 8                                         !
!                                                                           !
!     INPUT  : 01) xx_value  -> New interpolated x array with points        !
!              02) nxyvalue  -> # of elements in xx_value and yy_value      !
!              03) xold_vec  -> Old x vector (abcissas)                     !
!              04) yold_vec  -> Old y vector (ordenadas)                    !
!              05) nold_vec  -> # of elements in xold_vec and yold_vec      !
!              06) verbosity -> Print & Check screen                        !
!                                                                           !
!     OUTPUT : 01) yy_value -> New interpolated y array with points         !
!              02) IsKeepOn -> Flag, if == 0 then there's a problem         !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Wed May  2 10:00:52 WEST 2012                                !
!              Fri Dec 28 13:53:36 WET  2012                                !
!              Sun Mar 10 10:05:03 WET  2013                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE LINdexerpol( xx_value,yy_value,nxyvalue,xold_vec,yold_vec,       &
                        nold_vec,IsKeepOn,verbosity )

    use ModDataType

    implicit none
    integer  (kind=IB), intent(in) :: nold_vec,nxyvalue
    integer  (kind=IB), intent(out) :: IsKeepOn
    integer  (kind=IB), optional :: verbosity
    integer  (kind=IB) :: in_loop2,N_indice,IsShowOn

    real     (kind=RP), dimension(0:nold_vec-1), intent(in) :: xold_vec,yold_vec
    real     (kind=RP), dimension(0:nxyvalue-1), intent(in) :: xx_value
    real     (kind=RP), dimension(0:nxyvalue-1), intent(out) :: yy_value

    character (len=CH) :: W1aux,W2aux

    real     (kind=RP), dimension(0:nold_vec-1) :: a_vec,b_vec

    intrinsic adjustl, maxloc, trim
    
    !f2py real     (kind=RP), intent(in) :: xold_vec
    !f2py real     (kind=RP), intent(in) :: yold_vec
    !f2py                     intent(hide), depend(xold_vec) :: nold_vec=shape(xold_vec,0)
    !f2py                     intent(hide), depend(yold_vec) :: nold_vec=shape(yold_vec,0)

    !f2py real     (kind=RP), intent(in)  :: xx_value 
    !f2py real     (kind=RP), intent(out) :: yy_value 
    !f2py                     intent(hide), depend(xx_value) :: nxyvalue=shape(xx_value,0)
    !f2py                     intent(hide), depend(yy_value) :: nxyvalue=shape(yy_value,0)

    !f2py integer  (kind=IB), optional :: verbosity=0

    if ( present(verbosity) ) then
        IsShowOn = verbosity
    else
        IsShowOn = 0_IB
    end if

    if ( nold_vec < 1 ) then
       if ( IsShowOn == 1_IB ) then
          write (*,'(4x,a)') '[PROBLEM_INT] @@@@@@@@@@@@@@@@@@@@@@@@'
          write (*,'(4x,a)') '[Interpolado] nold_vec < 1 dimension @'
       end if
       yy_value = -999.0_RP
       IsKeepOn = 0_IB
       return
    end if
    
    if ( IsShowOn == 1_IB ) then
       write (*,'(4x,a)') '[LINdexerpol]'
    end if
    
    a_vec(0:nold_vec-2)  = (yold_vec(1:nold_vec-1) - yold_vec(0:nold_vec-2))&
                         / (xold_vec(1:nold_vec-1) - xold_vec(0:nold_vec-2))
    b_vec(0:nold_vec-2)  =  yold_vec(0:nold_vec-2) - a_vec(0:nold_vec-2)    &
                         *  xold_vec(0:nold_vec-2)
    a_vec(nold_vec-1)    = (yold_vec(nold_vec-1)   - yold_vec(nold_vec-2))  &
                         / (xold_vec(nold_vec-1)   - xold_vec(nold_vec-2))
    b_vec(nold_vec-1)    =  yold_vec(nold_vec-1)   - a_vec(nold_vec-1)      &
                         *  xold_vec(nold_vec-1)
    
    N_indice = -999_IB
    do in_loop2=0,nxyvalue-1
       if ( xx_value(in_loop2) >= xold_vec(0) .and.                         &
            xx_value(in_loop2) <= xold_vec(nold_vec-1) ) then
          if ( N_indice < 0_IB ) then
             N_indice = maxloc( xold_vec, dim=1, mask=xold_vec<=xx_value(in_loop2) )
          else
             N_indice = N_indice                                            &
                      + maxloc( xold_vec(N_indice:nold_vec-1), dim=1,       &
                  mask=xold_vec(N_indice:nold_vec-1)<=xx_value(in_loop2) )
          end if
       else if ( xx_value(in_loop2) < xold_vec(0)  ) then
          N_indice = 1
       else if ( xx_value(in_loop2) > xold_vec(nold_vec-1)  ) then
          N_indice = nold_vec-1
       end if
       !write (*,*) N_indice
       !write (*,*) N_indice,xold_vec(N_indice),xx_value(in_loop2)
       !write (*,*) xx_value(in_loop2)
       
       yy_value(in_loop2) = a_vec(N_indice-1) * xx_value(in_loop2) + b_vec(N_indice-1)
    end do

    if ( IsShowOn == 1_IB ) then
       do in_loop2=1,nxyvalue
          write (W1aux,'(f15.4)') xx_value(in_loop2)
          write (W2aux,'(f15.4)') yy_value(in_loop2)
          write (*,'(4x,a,a,a,a)') '... xx_value(in_loop2): ',              &
               trim(adjustl(W1aux)),' ==> yy_value: ',trim(adjustl(W2aux))
       end do
    end if
       
    if ( IsShowOn == 1_IB ) then
       write (*,'(4x,a)') '[LINdexerpol]'
    end if

    return
END SUBROUTINE LINdexerpol
! ###########################################################################

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE author_LINdexerpol( a )
  use ModDataType

  implicit none
  
  character (len=21), intent(out) :: a

  !f2py intent(out) :: a

  a = 'Written by Jean Gomes'
  
END SUBROUTINE author_LINdexerpol
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Jean@Porto - Fri Sep 30 15:30:49 AZOST 2011 +++++++++++++++++++++++++++++++

! *** Test ******************************************************************
!          PROGRAM GeneralTest
!            use ModDataType
!            implicit none
!            integer  (kind=IB) :: i,j,n
!            integer  (kind=IB), parameter :: Nl_max=80000
!            integer  (kind=IB) :: IsKeepOn,Int_Type,ilastval
!            real     (kind=RP), dimension(Nl_max) :: l,f,e,m
!            real     (kind=RP) :: int,lambda_i,lambda_f,ll1,ff1,ll2,ff2
!
!           END PROGRAM GeneralTest
! *** Test ******************************************************************

! *** Number : 002                                                          !
!
! 1) LINdexerpol
! 2) author_LINdexerpol

! ###########################################################################
!     RESUME : Rebinning of input vector on a new grid and returns the      !
!              output array. This routine uses the derivative of a          !
!              cumulative function to guarantee the conservation of         !
!              density flux while rebinning the spectrum.                   !
!                                                                           !
!     OBS.  :  Central wavelengths must be specified to compute the         !
!              wavelengths at the edges of the pixels. This routine         !
!              assumes a monotonically increasing function for 'X',         !
!              that can be unequally spaced.                                !
!                                                                           !
!              The Cumulative function has several ways to be               !
!              interpolated:                                                !
!                                                                           !
!              Interpolation Schemes:                                       !
!              00) slow_int -> AkimaSpline                                  !
!              01) slow_int -> Interpolado                                  !
!              02) slow_int -> LINdexerpol                                  !
!              03) slow_int -> LINinterpol                                  !
!              04) slow_int -> SPLINE1DArr                                  !
!              05) slow_int -> SPLINE3DArr                                  !
!                                                                           !
!              The default is LINinterpol                                   !
!                                                                           !
!     Input           arguments = 7                                         !
!     Output          arguments = 2                                         !
!     Optional        arguments = 2                                         !
!     Total number of arguments = 11                                        !
!                                                                           !
!     INPUT  : 01) Orlambda -> New 'X' vector                               !
!              02) Nrlambda -> Number of elements in new 'X' vector         !
!              03) O_lambda -> Old 'X' vector (Abscissa)                    !
!              04) O_fluxes -> Old 'Y' vector (Ordinate)                    !
!              05) N_lambda -> Number of elements in old 'X' vector         !
!              06) per_bins -> [0: Not conserve flux , 1: Conserve flux  ]  !
!              07) slow_int -> [0 -- 5]                                     !
!              08) fill_val  -> Value to fill values outside boundary       !
!              09) verbosity -> Optional variable to print & check          !
!                                                                           !
!     OUTPUT : 01) Orfluxes -> New 'Y' vector                               !
!              02) IsKeepOn -> Flag, if == 0 then there's a problem         !
!                                                                           !
!     PYTHON : Python compatibility using f2py revised. Better usage        !
!              with numpy.                                                  !
!                                                                           !
!     EXTRA ROUTINES : Those mentioned in slow_int interpolation scheme.    !
!                                                                           !
!     LOG: Modified to take into account Y negative values                  !
!          and minor corrections in the recovered Y values                  !
!          Two different corrections: One related to eps values in the      !
!          cumulative function and another one related to the cumulative    !
!          being set erroneously to zero.                                   !
!                                                                           !
!     Written: Jean Michel Gomes                                            !
!     Checked: Sat Dec  8 12:03:44 WET  2012                                !
!              Fri Dec 28 15:34:27 WET  2012                                !
!              Wed Apr 29 18:13:43 WEST 2015                                !
!              Thu Oct 20 21:55:02 WEST 2016                                !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE FluxConSpec( Orlambda,Orfluxes,Nrlambda,O_lambda,O_fluxes,       &
                        N_lambda,per_bins,slow_int,IsKeepOn,fill_val,       &
                        verbosity )

    use ModDataType
    
    implicit none
    integer  (kind=IB), intent(in) :: N_lambda,Nrlambda
    integer  (kind=IB)  :: countdel,indexing,IsShowOn,ilastval,Nz,i
    integer  (kind=IB), optional :: verbosity
    integer  (kind=IB), intent(in) :: per_bins,slow_int
    integer  (kind=IB), intent(out) :: IsKeepOn

    integer  (kind=IB) :: Is_Index
    !integer  (kind=IB) :: incfd, ierr, findloc_min, findloc_max, Is_Index
    !integer  (kind=IB) :: ii, jj, k, yydegree
    !integer  (kind=IB), dimension(2) :: next
    
    real     (kind=RP), dimension(N_lambda), intent(in) :: O_lambda,O_fluxes
    real     (kind=RP), dimension(Nrlambda), intent(out) :: Orfluxes
    real     (kind=RP), dimension(Nrlambda), intent(in) :: Orlambda
                                                    
    real     (kind=RP), allocatable, dimension(:) :: auxvecxx,auxvecyy,     &
                                                     auxvecww,auxvecff,     &
                                                     auxvecgg,D_lambda,     &
                                                     Drlambda,O_cumul1,     &
                                                     O_cumul2!,Derivada
    real     (kind=RP), optional :: fill_val
    real     (kind=RP) :: max_base,min_base,llow_new,lupp_new,ratioeps,     &
                          sumcumul,maxcumul,tolrance,delta_x,e

    character (len=CH) :: W1aux,W2aux!,string_t
    
    !f2py real     (kind=RP), intent(in) :: Orlambda
    !f2py real     (kind=RP), intent(out) :: Orfluxes
    !f2py                     intent(hide), depend(Orlambda) :: Nrlambda=shape(Orlambda,0)

    !f2py real     (kind=RP), intent(in) :: O_lambda, O_fluxes
    !f2py                     intent(hide), depend(O_lambda) :: N_lambda=shape(O_lambda,0)

    !f2py real     (kind=RP), optional :: fill_val=0.0
    
    !f2py integer  (kind=IB), intent(out) :: IsKeepOn
    !f2py integer  (kind=IB), intent(in) :: per_bins,slow_int
    !f2py                     intent(in), optional :: verbosity=0
    
! *** Verbosity mode ********************************************************
    if ( present(verbosity) ) then
        IsShowOn = verbosity
    else
        IsShowOn = 0_IB
    end if
! *** Verbosity mode ********************************************************

    IsKeepOn = 1_IB
    
! *** Check arrays **********************************************************
    !N_fluxes = size(O_fluxes)
    !N_lambda = size(O_lambda)
    !Nrlambda = size(Orlambda)
    !Nrfluxes = size(Orfluxes)

    !if ( N_lambda /= N_fluxes ) then
    !    write (*,'(4x,a)')  '[PROBLEM_FIT] @@@@@@@@@@@@@@@@@@@@@@@@'
    !    write (*,'(4x,a)')  '[FluxConSpec] N_fluxes !== N_lambda @@'
    !    write (*,'(4x,a,i10,a,i10)')  '[FluxConSpec]',N_fluxes,' !== ',     &
    !                                  N_lambda
    !
    !    !open  (unit=10,file=arq_outs,position='append',status='unknown')
    !    !write (10,'(4x,a)') '[PROBLEM_FIT] @@@@@@@@@@@@@@@@@@@@@@@@'
    !    !write (10,'(4x,a)') '[FluxConSpec] N_fluxes !== N_lambda @@'
    !    !string_t = fdate()
    !    !write (10,'(4x,a,a)') 'FADO - ',trim(adjustl(string_t))
    !    !close (10)
    !
    !    IsKeepOn = 0
    !    return
    !end if
    !
    !if ( Nrlambda /= Nrfluxes ) then
    !    write (*,'(4x,a)')  '[PROBLEM_FIT] @@@@@@@@@@@@@@@@@@@@@@@@'
    !    write (*,'(4x,a)')  '[FluxConSpec] Nrfluxes !== Nrlambda @@'
    !
    !    !open  (unit=10,file=arq_outs,position='append',status='unknown')
    !    !write (10,'(4x,a)') '[PROBLEM_FIT] @@@@@@@@@@@@@@@@@@@@@@@@'
    !    !write (10,'(4x,a)') '[FluxConSpec] Nrfluxes !== Nrlambda @@'
    !    !string_t = fdate()
    !    !write (10,'(4x,a,a)') 'FADO - ',trim(adjustl(string_t))
    !    !close (10)
    !
    !    IsKeepOn = 0
    !    return
    !end if

! *** WARNING ***************************************************************
!     RESUME : This part has been removed to let the code more general.     !
!     N_lambda = count( O_lambda > 0.0_RP )                                 !
!     N_fluxes = N_lambda                                                   !
!     Nrlambda = count( Orlambda > 0.0_RP )                                 !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !write (*,*) N_lambda,Nrlambda
    
    if ( N_lambda < 2_IB .OR. Nrlambda < 2_IB ) then
        write (*,'(4x,a)')  '[PROBLEM_FIT] @@@@@@@@@@@@@@@@@@@@@@@@'
        write (*,'(4x,a)')  '[FluxConSpec] not sufficient points @@'
    
        IsKeepOn = 0_IB
        return
    end if

    countdel = count( (O_lambda(2:N_lambda)-O_lambda(1:N_lambda-1))<=0.0_RP )
    if ( countdel > 0_IB ) then
        write (*,'(4x,a)')  '[PROBLEM_FIT] @@@@@@@@@@@@@@@@@@@@@@@@'
        write (*,'(4x,a)')  '[FluxConSpec] l-> Is not monotonically'

        IsKeepOn = 0_IB
        return
    end if
! *** Check arrays **********************************************************

! *** Print screen  *********************************************************
    if ( IsShowOn == 1_IB ) then
        llow_new = Orlambda(1)
        lupp_new = Orlambda(Nrlambda)
        write (*,*)
        write (*,'(4x,a)') '[FluxConSpec]'
        write (W1aux,'(i10)') per_bins
        if ( per_bins == 1 ) then
            write (*,'(4x,a,a,a)') '... per_bins: ',trim(adjustl(W1aux)),   &
                                   ' -- [Conserving flux density]'
        else
            write (*,'(4x,a,a,a)') '... per_bins: ',trim(adjustl(W1aux)),   &
                                   ' -- [Not Conserving flux density]'
        end if
        write (W1aux,'(f17.5)') llow_new
        write (W2aux,'(f17.5)') lupp_new
        write (*,'(4x,5(a))') '[Re-sampling] ==> ',trim(adjustl(W1aux)),    &
                              ' <---> ',trim(adjustl(W2aux)),' A'
        write (*,'(4x,a,i10,a,i10,a)')                                      &
                     '------------------------------------------------------'
        write (*,'(4x,a,i12,a,i12,a)')                                      &
                     '| N_lambda ==>',N_lambda,' | Nrlambda ==>',Nrlambda,'|'
        write (*,'(4x,a,i10,a,i10,a)')                                      &
                     '------------------------------------------------------'
    end if
! *** Print screen  *********************************************************

! *** Compatibility checks **************************************************
    allocate( auxvecxx(N_lambda+1) )
    allocate( O_cumul1(N_lambda+1) )

    allocate( auxvecyy(Nrlambda+1) )
    allocate( auxvecww(Nrlambda+1) )
    allocate( O_cumul2(Nrlambda+1) )

    allocate( D_lambda(N_lambda) )
    allocate( auxvecff(N_lambda) )

    allocate( Drlambda(Nrlambda) )
    allocate( auxvecgg(Nrlambda) )

! *** Min & Max values ***********
    min_base = max( minval(O_lambda),minval(Orlambda) )
    max_base = min( maxval(O_lambda),maxval(Orlambda) )
    !write (*,*) min_base,max_base

! *** Mid-bin values *************
    D_lambda(2:N_lambda) = O_lambda(2:N_lambda) - O_lambda(1:N_lambda-1)
    D_lambda(1)          = D_lambda(2)
    D_lambda(1:N_lambda) = 0.500000000000000_RP * D_lambda(1:N_lambda)
    auxvecxx(1:N_lambda) = O_lambda(1:N_lambda) - D_lambda(1:N_lambda)
    auxvecxx(N_lambda+1) = O_lambda(N_lambda+0) + D_lambda(N_lambda-1)

! *** Test ******************************************************************
    !do i=1,N_lambda
    !   write (*,*) auxvecxx(i),O_lambda(i),D_lambda(i),i
    !end do
! *** Test ******************************************************************

    if ( count(auxvecxx(2:N_lambda)-auxvecxx(1:N_lambda-1)<=0.0_RP )>0_IB ) then
        write (*,'(4x,a)')  '[PROBLEM_FIT] @@@@@@@@@@@@@@@@@@@@@@@@'
        write (*,'(4x,a)')  '[FluxConSpec] l is not monotonical @@@'

        IsKeepOn = 0_IB
        return
    end if

    Drlambda(2:Nrlambda) = Orlambda(2:Nrlambda) - Orlambda(1:Nrlambda-1)
    Drlambda(1)          = Drlambda(2)
    Drlambda(1:Nrlambda) = 0.5_RP * Drlambda(1:Nrlambda)
    auxvecyy(1:Nrlambda) = Orlambda(1:Nrlambda) - Drlambda(1:Nrlambda)
    auxvecyy(Nrlambda+1) = Orlambda(Nrlambda+0) + Drlambda(Nrlambda-1)
! *** Compatibility checks **************************************************

! *** Get bin widths ********************************************************
    D_lambda(1:N_lambda) = auxvecxx(2:N_lambda+1) - auxvecxx(1:N_lambda)
    Drlambda(1:Nrlambda) = auxvecyy(2:Nrlambda+1) - auxvecyy(1:Nrlambda)

    if ( per_bins == 1_IB ) then
! *** Unit correction ************
        auxvecff(1:N_lambda) = O_fluxes(1:N_lambda) * D_lambda(1:N_lambda)
    else
        auxvecff(1:N_lambda) = O_fluxes(1:N_lambda)
    end if
! *** Get bin widths ********************************************************

! *** Make cumulative function **********************************************
    tolrance = MachinePrecision( 1_IB )
    O_cumul1(1) = 0.0_RP
    maxcumul    = O_lambda(1)
    sumcumul    = abs( sum( auxvecff(1:N_lambda) ) )
    do indexing=1,N_lambda
        O_cumul1(indexing+1) = O_cumul1(indexing) + auxvecff(indexing)
! --- Test to see whether the original cumulative function varies -----------
        ratioeps = abs(O_cumul1(indexing+1)-O_cumul1(indexing)) / sumcumul
        if ( ratioeps >= tolrance .AND. indexing > 1_IB ) then
           maxcumul = O_lambda(indexing-1)
        end if
! --- Test to see whether the original cumulative function varies -----------
        !write (*,*) O_lambda(indexing),O_cumul1(indexing),sumcumul,ratioeps
    end do
    maxcumul = min( maxcumul,maxval(ARRAY=O_lambda,MASK=O_fluxes/=0.0) )
    maxcumul = int( maxcumul )
    !write (*,*) maxcumul
    !stop
! *** Make cumulative function **********************************************

! *** Interpolate cumulative function ***************************************
    select case (slow_int)
    case default
       ilastval = -999
       call LINinterpol( auxvecyy,O_cumul2,Nrlambda+1,auxvecxx,O_cumul1,    &
                         N_lambda+1,ilastval,IsKeepOn,IsShowOn )
    case (0)
       delta_x = 0.1
       call AkimaSpline( auxvecyy,O_cumul2,Nrlambda+1,auxvecxx,O_cumul1,    &
                         N_lambda+1,delta_x,IsKeepOn,IsShowOn )
    case (1)
       Is_Index = 0_IB
       call Interpolado( auxvecyy,O_cumul2,Nrlambda+1,auxvecxx,O_cumul1,    &
                         N_lambda+1,IsKeepOn,Is_Index,IsShowOn )
    case (2)
       call LINdexerpol( auxvecyy,O_cumul2,Nrlambda+1,auxvecxx,O_cumul1,    &
                         N_lambda+1,IsKeepOn,IsShowOn )
    case (3)
       ilastval = -999
       call LINinterpol( auxvecyy,O_cumul2,Nrlambda+1,auxvecxx,O_cumul1,    &
                         N_lambda+1,ilastval,IsKeepOn,IsShowOn )
    case (4)
       e = 1.0e-8_RP
       Is_Index = 0_IB
       call SPLINE1DArr( auxvecyy,O_cumul2,Nrlambda+1,auxvecxx,O_cumul1,    &
                         N_lambda+1,e,IsKeepOn,Is_Index,IsShowOn )
    case (5)
       call SPLINE3DArr( auxvecyy,O_cumul2,Nrlambda+1,auxvecxx,O_cumul1,    &
                         N_lambda+1,IsKeepOn,IsShowOn )
    end select
! *** Interpolate cumulative function ***************************************

! *** Test interpolated cumulative function *********************************
!        do indexing=1,Nrlambda+1
!           if (indexing.LE.N_lambda) then
!              write (*,*) auxvecyy(indexing),O_cumul2(indexing),           &
!                          auxvecxx(indexing),O_cumul1(indexing)
!           else
!              write (*,*) auxvecyy(indexing),O_cumul2(indexing),' 0.0 ',   &
!                          ' 0.0 '
!           end if
!        end do
!        stop
! *** Test interpolated cumulative function *********************************

! *** Undo accumulation *****************************************************
    sumcumul = abs(O_cumul1(N_lambda))
    auxvecgg(1:Nrlambda) = O_cumul2(2:Nrlambda+1)-O_cumul2(1:Nrlambda)
    !write (*,*) auxvecgg(1:Nrlambda)
    
    !if ( count( auxvecgg(1:Nrlambda) < 0.0_RP ) > 0 ) then
    !   write (*,*) "Habemus negativo"
    !else
    !   write (*,*) "Non Habemus negativo"
    !end if
    
    do indexing=1,Nrlambda

       ! ratioeps = abs(sumcumul-O_cumul2(indexing))/sumcumul

       !if ( Orlambda(indexing)  < min_base .OR. Orlambda(indexing)  >     &
       !                           max_base .OR. Orlambda(indexing)  >=    &
       !                          maxcumul .OR. ratioeps < tolrance  .OR.  &
       !    Orlambda(indexing) >=                                          &
       !            int(maxval(ARRAY=O_lambda,MASK=O_fluxes/=0.0_RP)) ) then
       !   !auxvecgg(indexing) = 0.0_RP
       !end if

       if ( per_bins == 1_IB ) then
            auxvecgg(indexing) = auxvecgg(indexing) / Drlambda(indexing)
       end if
       if ( Orlambda(indexing) > O_lambda(N_lambda) ) then
          auxvecgg(indexing) = fill_val !0.0_RP
       end if
       if  ( Orlambda(indexing) < O_lambda(1) ) then
          auxvecgg(indexing) = fill_val !0.0_RP
       end if

       !write (*,*) indexing,auxvecgg(indexing),O_cumul2(indexing),        &
       !            Drlambda(indexing),Orlambda(indexing),ratioeps
   end do
   !stop
! *** Undo accumulation *****************************************************

! *** Export result *********************************************************
   Orfluxes(1:Nrlambda) = auxvecgg(1:Nrlambda)
! *** Export result *********************************************************
   
! *** Print screen **********************************************************
    if ( IsShowOn == 2_IB ) then
        Nz = max(N_lambda,Nrlambda)
        do i=1,Nz
!Print screen **********************************************************
            if ( i <= N_lambda .AND. i <= Nrlambda ) then
                write (*,'(4(e15.4))') O_lambda(i),O_fluxes(i),Orlambda(i), &
                                       Orfluxes(i)
            end if
            if ( i  > N_lambda .AND. i <= Nrlambda ) then
                write (*,'(2(a15),2(e15.4))') ' 0.0 ',' 0.0 ',Orlambda(i),  &
                                                              Orfluxes(i)
            end if
            if ( i <= N_lambda .AND. i  > Nrlambda ) then
                write (*,'(2(e15.4),2(a15))') O_lambda(i),O_fluxes(i),      &
                                              ' 0.0 ',' 0.0 '
            end if
        end do
    end if
    if ( IsShowOn == 1_IB ) then
        write (*,'(4x,a)') '[FluxConSpec]'
    end if
! *** Print screen **********************************************************

! *** Deallocate from memory ************************************************
    deallocate( auxvecgg )
    deallocate( auxvecww )
    deallocate( O_cumul1 )
    deallocate( O_cumul2 )
    deallocate( auxvecff )
    deallocate( D_lambda )
    deallocate( Drlambda )
    deallocate( auxvecxx )
    deallocate( auxvecyy )
! *** Deallocate from memory ************************************************

    return

  contains

! ###########################################################################
!     RESUME : This subroutine uses the MINPACK subroutines.                !
!                                                                           !
! *** Function MachinePrecision ******************************************* !
!                                                                           !
!     This function provides real machine parameters when the               !
!     appropriate set of data statements is activated (by removing the      !
!     c from column 1) and all other data statements are rendered           !
!     inactive. Most of the parameter values were obtained from the         !
!     corresponding Bell Laboratories Port Library function.                !
!                                                                           !
!     The function statement is:                                            !
!                                                                           !
!     real (kind=RP) :: function MachinePrecision( i )                      !
!                                                                           !
!     where                                                                 !
!                                                                           !
!     i is an integer input variable set to 1, 2, or 3 which selects        !
!     the desired machine parameter. If the machine has t base b            !
!     digits and its smallest and largest exponents are emin and emax,      !
!     respectively, then these parameters are                               !
!                                                                           !
!     MachinePrecision(1) = b**(1 - t), the machine precision,              !
!                                                                           !
!     MachinePrecision(2) = b**(emin - 1), the smallest magnitude,          !
!                                                                           !
!     MachinePrecision(3) = b**emax*(1 - b**(-t)), the largest magnitude.   !
!                                                                           !
! ------------------------------------------------------------------------- !
!                                                                           !
!     Machine constants for the IBM 360/370 series, the Amdahl 470/V6,      !
!     the ICL 2900, the Itel AS/6, the Xerox Sigma 5/7/9 and the Sel        !
!     systems 85/86.                                                        !
!                                                                           !
!     data mcheps(1),mcheps(2) / z34100000, z00000000 /                     !
!     data minmag(1),minmag(2) / z00100000, z00000000 /                     !
!     data maxmag(1),maxmag(2) / z7fffffff, zffffffff /                     !
!                                                                           !
!     Machine constants for the Honeywell 600/6000 series.                  !
!                                                                           !
!     data mcheps(1),mcheps(2) / o606400000000, o000000000000 /             !
!     data minmag(1),minmag(2) / o402400000000, o000000000000 /             !
!     data maxmag(1),maxmag(2) / o376777777777, o777777777777 /             !
!                                                                           !
!     Machine constants for the CDC 6000/7000 series.                       !
!                                                                           !
!     data mcheps(1) / 15614000000000000000b /                              !
!     data mcheps(2) / 15010000000000000000b /                              !
!                                                                           !
!     data minmag(1) / 00604000000000000000b /                              !
!     data minmag(2) / 00000000000000000000b /                              !
!                                                                           !
!     data maxmag(1) / 37767777777777777777b /                              !
!     data maxmag(2) / 37167777777777777777b /                              !
!                                                                           !
!     Machine constants for the PDP-10 (KA processor).                      !
!                                                                           !
!     data mcheps(1),mcheps(2) / "114400000000, "000000000000 /             !
!     data minmag(1),minmag(2) / "033400000000, "000000000000 /             !
!     data maxmag(1),maxmag(2) / "377777777777, "344777777777 /             !
!                                                                           !
!     Machine constants for the PDP-10 (KI processor).                      !
!                                                                           !
!     data mcheps(1),mcheps(2) / "104400000000, "000000000000 /             !
!     data minmag(1),minmag(2) / "000400000000, "000000000000 /             !
!     data maxmag(1),maxmag(2) / "377777777777, "377777777777 /             !
!                                                                           !
!     Machine constants for the PDP-11.                                     !
!                                                                           !
!     data mcheps(1),mcheps(2) /   9472,      0 /                           !
!     data mcheps(3),mcheps(4) /      0,      0 /                           !
!                                                                           !
!     data minmag(1),minmag(2) /    128,      0 /                           !
!     data minmag(3),minmag(4) /      0,      0 /                           !
!                                                                           !
!     data maxmag(1),maxmag(2) /  32767,     -1 /                           !
!     data maxmag(3),maxmag(4) /     -1,     -1 /                           !
!                                                                           !
!     Machine constants for the Burroughs 6700/7700 systems.                !
!                                                                           !
!     data mcheps(1) / o1451000000000000 /                                  !
!     data mcheps(2) / o0000000000000000 /                                  !
!                                                                           !
!     data minmag(1) / o1771000000000000 /                                  !
!     data minmag(2) / o7770000000000000 /                                  !
!                                                                           !
!     data maxmag(1) / o0777777777777777 /                                  !
!     data maxmag(2) / o7777777777777777 /                                  !
!                                                                           !
!     Machine constants for the Burroughs 5700 system.                      !
!                                                                           !
!     data mcheps(1) / o1451000000000000 /                                  !
!     data mcheps(2) / o0000000000000000 /                                  !
!                                                                           !
!     data minmag(1) / o1771000000000000 /                                  !
!     data minmag(2) / o0000000000000000 /                                  !
!                                                                           !
!     data maxmag(1) / o0777777777777777 /                                  !
!     data maxmag(2) / o0007777777777777 /                                  !
!                                                                           !
!     Machine constants for the Burroughs 1700 system.                      !
!                                                                           !
!     data mcheps(1) / zcc6800000 /                                         !
!     data mcheps(2) / z000000000 /                                         !
!                                                                           !
!     data minmag(1) / zc00800000 /                                         !
!     data minmag(2) / z000000000 /                                         !
!                                                                           !
!     data maxmag(1) / zdffffffff /                                         !
!     data maxmag(2) / zfffffffff /                                         !
!                                                                           !
!     Machine constants for the Univac 1100 series.                         !
!                                                                           !
!     data mcheps(1),mcheps(2) / o170640000000, o000000000000 /             !
!     data minmag(1),minmag(2) / o000040000000, o000000000000 /             !
!     data maxmag(1),maxmag(2) / o377777777777, o777777777777 /             !
!                                                                           !
!     Machine constants for the Data General Eclipse S/200.                 !
!                                                                           !
!     Note - it may be appropriate to include the following card -          !
!     static dmach(3)                                                       !
!                                                                           !
!     data minmag/20k,3*0/,maxmag/77777k,3*177777k/                         !
!     data mcheps/32020k,3*0/                                               !
!                                                                           !
!     Machine constants for the Harris 220.                                 !
!                                                                           !
!     data mcheps(1),mcheps(2) / '20000000, '00000334 /                     !
!     data minmag(1),minmag(2) / '20000000, '00000201 /                     !
!     data maxmag(1),maxmag(2) / '37777777, '37777577 /                     !
!                                                                           !
!     Machine constants for the Cray-1.                                     !
!                                                                           !
!     data mcheps(1) / 0376424000000000000000b /                            !
!     data mcheps(2) / 0000000000000000000000b /                            !
!                                                                           !
!     data minmag(1) / 0200034000000000000000b /                            !
!     data minmag(2) / 0000000000000000000000b /                            !
!                                                                           !
!     data maxmag(1) / 0577777777777777777777b /                            !
!     data maxmag(2) / 0000007777777777777776b /                            !
!                                                                           !
!     Machine constants for the Prime 400.                                  !
!                                                                           !
!     data mcheps(1),mcheps(2) / :10000000000, :00000000123 /               !
!     data minmag(1),minmag(2) / :10000000000, :00000100000 /               !
!     data maxmag(1),maxmag(2) / :17777777777, :37777677776 /               !
!                                                                           !
!     Machine constants for the VAX-11.                                     !
!                                                                           !
!     data mcheps(1),mcheps(2) /   9472,  0 /                               !
!     data minmag(1),minmag(2) /    128,  0 /                               !
!     data maxmag(1),maxmag(2) / -32769, -1 /                               !
!                                                                           !
!     Machine constants for IEEE machines.                                  !
!                                                                           !
!     Written: Argonne national laboratory. minpack project. march 1980.    !
!              Burton s. Garbow, Kenneth E. Hillstrom, Jorge J.             !
!                                                                           !
!     Written: Readapted to f90 by Jean Michel Gomes                        !
!     Checked: Thu Oct 27 09:46:50 WEST 2016                                !
! ###########################################################################
REAL (kind=RP) FUNCTION MachinePrecision( i )
    use ModDataType
    implicit none
    integer  (kind=IB), intent(in) :: i
    integer  (kind=IB) :: mcheps(4)
    integer  (kind=IB) :: minmag(4)
    integer  (kind=IB) :: maxmag(4)
    real     (kind=RP) :: dmach(3)

    !f2py integer  (kind=IB), intent(in) :: i
    !f2py real     (kind=RP), intent(out) :: MachinePrecision
    
    equivalence ( dmach(1),mcheps(1) )
    equivalence ( dmach(2),minmag(1) )
    equivalence ( dmach(3),maxmag(1) )
    
    data dmach(1) /2.22044604926e-016_RP/
    data dmach(2) /2.22507385852e-308_RP/
    data dmach(3) /1.79769313485e+308_RP/
    
    MachinePrecision = dmach(i)
    return
  END FUNCTION MachinePrecision
! ###########################################################################

END SUBROUTINE FluxConSpec
! ###########################################################################

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
SUBROUTINE author_FluxConSpec( a )
  use ModDataType

  implicit none
  
  character (len=21), intent(out) :: a

  !f2py intent(out) :: a

  a = 'Written by Jean Gomes'
  
END SUBROUTINE author_FluxConSpec
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! Jean@Porto - Wed Dec  5 11:04:34 WET 2012 +++++++++++++++++++++++++++++++++

! *** Test ******************************************************************
!PROGRAM GeneralTest
!END PROGRAM GeneralTest
! *** Test ******************************************************************

! *** Number : 002                                                          !
!
! 1) FluxConSpec
! 2) author_FluxConSpec
